//+------------------------------------------------------------------+
//|                                            MA-MACD MultiPair.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window

extern int MaPeriod1 =  5;
extern int MaPeriod2 = 75;
extern int MaPeriod3 = 85;
extern int MacdFast  = 15;
extern int MacdSlow  = 26;

double BarTime,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z;
int XMA;
int XMA2=9;
double tx;
color col;
double EUR,USD,GBP,CHF,JPY,CAD,AUD;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
ObjectCreate("EURUSD_Title",OBJ_LABEL,0,0,0);
ObjectSetText("EURUSD_Title","EURUSD",20,"Impact",LimeGreen);
ObjectCreate("EURUSD_MA",OBJ_LABEL,0,0,0);
ObjectSetText("EURUSD_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("EURUSD_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("EURUSD_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("EURUSD_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("EURUSD_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("EURUSD_P1",OBJ_LABEL,0,0,0);
ObjectSetText("EURUSD_P1","EUR 0%",10,"Arial",0x777777);
ObjectCreate("EURUSD_P2",OBJ_LABEL,0,0,0);
ObjectSetText("EURUSD_P2","USD 0%",10,"Arial",0x777777);

ObjectCreate("GBPUSD_Title",OBJ_LABEL,0,0,0);
ObjectSetText("GBPUSD_Title","GBPUSD",20,"Impact",LimeGreen);
ObjectCreate("GBPUSD_MA",OBJ_LABEL,0,0,0);
ObjectSetText("GBPUSD_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("GBPUSD_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("GBPUSD_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("GBPUSD_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("GBPUSD_Trade","Waitin!",10,"Arial",0xff0000);
ObjectCreate("GBPUSD_P1",OBJ_LABEL,0,0,0);
ObjectSetText("GBPUSD_P1","GBP 0%",10,"Arial",0x777777);
ObjectCreate("GBPUSD_P2",OBJ_LABEL,0,0,0);
ObjectSetText("GBPUSD_P2","USD 0%",10,"Arial",0x777777);

ObjectCreate("EURCHF_Title",OBJ_LABEL,0,0,0);
ObjectSetText("EURCHF_Title","EURCHF",20,"Impact",LimeGreen);
ObjectCreate("EURCHF_MA",OBJ_LABEL,0,0,0);
ObjectSetText("EURCHF_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("EURCHF_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("EURCHF_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("EURCHF_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("EURCHF_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("EURCHF_P1",OBJ_LABEL,0,0,0);
ObjectSetText("EURCHF_P1","EUR 0%",10,"Arial",0x777777);
ObjectCreate("EURCHF_P2",OBJ_LABEL,0,0,0);
ObjectSetText("EURCHF_P2","CHF 0%",10,"Arial",0x777777);

ObjectCreate("EURJPY_Title",OBJ_LABEL,0,0,0);
ObjectSetText("EURJPY_Title","EURJPY",20,"Impact",LimeGreen);
ObjectCreate("EURJPY_MA",OBJ_LABEL,0,0,0);
ObjectSetText("EURJPY_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("EURJPY_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("EURJPY_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("EURJPY_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("EURJPY_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("EURJPY_P1",OBJ_LABEL,0,0,0);
ObjectSetText("EURJPY_P1","EUR 0%",10,"Arial",0x777777);
ObjectCreate("EURJPY_P2",OBJ_LABEL,0,0,0);
ObjectSetText("EURJPY_P2","JPY 0%",10,"Arial",0x777777);

ObjectCreate("USDCHF_Title",OBJ_LABEL,0,0,0);
ObjectSetText("USDCHF_Title","USDCHF",20,"Impact",LimeGreen);
ObjectCreate("USDCHF_MA",OBJ_LABEL,0,0,0);
ObjectSetText("USDCHF_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("USDCHF_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("USDCHF_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("USDCHF_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("USDCHF_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("USDCHF_P1",OBJ_LABEL,0,0,0);
ObjectSetText("USDCHF_P1","USD 0%",10,"Arial",0x777777);
ObjectCreate("USDCHF_P2",OBJ_LABEL,0,0,0);
ObjectSetText("USDCHF_P2","CHF 0%",10,"Arial",0x777777);

ObjectCreate("USDJPY_Title",OBJ_LABEL,0,0,0);
ObjectSetText("USDJPY_Title","USDJPY",20,"Impact",LimeGreen);
ObjectCreate("USDJPY_MA",OBJ_LABEL,0,0,0);
ObjectSetText("USDJPY_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("USDJPY_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("USDJPY_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("USDJPY_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("USDJPY_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("USDJPY_P1",OBJ_LABEL,0,0,0);
ObjectSetText("USDJPY_P1","USD 0%",10,"Arial",0x777777);
ObjectCreate("USDJPY_P2",OBJ_LABEL,0,0,0);
ObjectSetText("USDJPY_P2","JPY 0%",10,"Arial",0x777777);

ObjectCreate("USDCAD_Title",OBJ_LABEL,0,0,0);
ObjectSetText("USDCAD_Title","USDCAD",20,"Impact",LimeGreen);
ObjectCreate("USDCAD_MA",OBJ_LABEL,0,0,0);
ObjectSetText("USDCAD_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("USDCAD_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("USDCAD_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("USDCAD_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("USDCAD_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("USDCAD_P1",OBJ_LABEL,0,0,0);
ObjectSetText("USDCAD_P1","USD 0%",10,"Arial",0x777777);
ObjectCreate("USDCAD_P2",OBJ_LABEL,0,0,0);
ObjectSetText("USDCAD_P2","CAD 0%",10,"Arial",0x777777);

ObjectCreate("EURAUD_Title",OBJ_LABEL,0,0,0);
ObjectSetText("EURAUD_Title","EURAUD",20,"Impact",LimeGreen);
ObjectCreate("EURAUD_MA",OBJ_LABEL,0,0,0);
ObjectSetText("EURAUD_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("EURAUD_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("EURAUD_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("EURAUD_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("EURAUD_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("EURAUD_P1",OBJ_LABEL,0,0,0);
ObjectSetText("EURAUD_P1","EUR 0%",10,"Arial",0x777777);
ObjectCreate("EURAUD_P2",OBJ_LABEL,0,0,0);
ObjectSetText("EURAUD_P2","AUD 0%",10,"Arial",0x777777);
/*****************************/
ObjectCreate("EURGBP_Title",OBJ_LABEL,0,0,0);
ObjectSetText("EURGBP_Title","EURGBP",20,"Impact",LimeGreen);
ObjectCreate("EURGBP_MA",OBJ_LABEL,0,0,0);
ObjectSetText("EURGBP_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("EURGBP_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("EURGBP_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("EURGBP_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("EURGBP_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("EURGBP_P1",OBJ_LABEL,0,0,0);
ObjectSetText("EURGBP_P1","EUR 0%",10,"Arial",0x777777);
ObjectCreate("EURGBP_P2",OBJ_LABEL,0,0,0);
ObjectSetText("EURGBP_P2","GBP 0%",10,"Arial",0x777777);

ObjectCreate("AUDUSD_Title",OBJ_LABEL,0,0,0);
ObjectSetText("AUDUSD_Title","AUDUSD",20,"Impact",LimeGreen);
ObjectCreate("AUDUSD_MA",OBJ_LABEL,0,0,0);
ObjectSetText("AUDUSD_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("AUDUSD_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("AUDUSD_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("AUDUSD_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("AUDUSD_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("AUDUSD_P1",OBJ_LABEL,0,0,0);
ObjectSetText("AUDUSD_P1","AUD 0%",10,"Arial",0x777777);
ObjectCreate("AUDUSD_P2",OBJ_LABEL,0,0,0);
ObjectSetText("AUDUSD_P2","USD 0%",10,"Arial",0x777777);

ObjectCreate("GBPCHF_Title",OBJ_LABEL,0,0,0);
ObjectSetText("GBPCHF_Title","GBPCHF",20,"Impact",LimeGreen);
ObjectCreate("GBPCHF_MA",OBJ_LABEL,0,0,0);
ObjectSetText("GBPCHF_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("GBPCHF_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("GBPCHF_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("GBPCHF_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("GBPCHF_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("GBPCHF_P1",OBJ_LABEL,0,0,0);
ObjectSetText("GBPCHF_P1","GBP 0%",10,"Arial",0x777777);
ObjectCreate("GBPCHF_P2",OBJ_LABEL,0,0,0);
ObjectSetText("GBPCHF_P2","CHF 0%",10,"Arial",0x777777);

ObjectCreate("GBPJPY_Title",OBJ_LABEL,0,0,0);
ObjectSetText("GBPJPY_Title","GBPJPY",20,"Impact",LimeGreen);
ObjectCreate("GBPJPY_MA",OBJ_LABEL,0,0,0);
ObjectSetText("GBPJPY_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("GBPJPY_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("GBPJPY_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("GBPJPY_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("GBPJPY_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("GBPJPY_P1",OBJ_LABEL,0,0,0);
ObjectSetText("GBPJPY_P1","GBP 0%",10,"Arial",0x777777);
ObjectCreate("GBPJPY_P2",OBJ_LABEL,0,0,0);
ObjectSetText("GBPJPY_P2","JPY 0%",10,"Arial",0x777777);

ObjectCreate("AUDCHF_Title",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCHF_Title","AUDCHF",20,"Impact",LimeGreen);
ObjectCreate("AUDCHF_MA",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCHF_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("AUDCHF_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCHF_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("AUDCHF_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCHF_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("AUDCHF_P1",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCHF_P1","AUD 0%",10,"Arial",0x777777);
ObjectCreate("AUDCHF_P2",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCHF_P2","CHF 0%",10,"Arial",0x777777);

ObjectCreate("AUDCAD_Title",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCAD_Title","AUDCAD",20,"Impact",LimeGreen);
ObjectCreate("AUDCAD_MA",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCAD_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("AUDCAD_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCAD_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("AUDCAD_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCAD_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("AUDCAD_P1",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCAD_P1","AUD 0%",10,"Arial",0x777777);
ObjectCreate("AUDCAD_P2",OBJ_LABEL,0,0,0);
ObjectSetText("AUDCAD_P2","CAD 0%",10,"Arial",0x777777);

ObjectCreate("AUDJPY_Title",OBJ_LABEL,0,0,0);
ObjectSetText("AUDJPY_Title","AUDJPY",20,"Impact",LimeGreen);
ObjectCreate("AUDJPY_MA",OBJ_LABEL,0,0,0);
ObjectSetText("AUDJPY_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("AUDJPY_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("AUDJPY_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("AUDJPY_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("AUDJPY_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("AUDJPY_P1",OBJ_LABEL,0,0,0);
ObjectSetText("AUDJPY_P1","AUD 0%",10,"Arial",0x777777);
ObjectCreate("AUDJPY_P2",OBJ_LABEL,0,0,0);
ObjectSetText("AUDJPY_P2","JPY 0%",10,"Arial",0x777777);

ObjectCreate("EURCAD_Title",OBJ_LABEL,0,0,0);
ObjectSetText("EURCAD_Title","EURCAD",20,"Impact",LimeGreen);
ObjectCreate("EURCAD_MA",OBJ_LABEL,0,0,0);
ObjectSetText("EURCAD_MA","MA NONE",10,"Arial",0x777777);
ObjectCreate("EURCAD_MACD",OBJ_LABEL,0,0,0);
ObjectSetText("EURCAD_MACD","MACD NONE",10,"Arial",0x777777);
ObjectCreate("EURCAD_Trade",OBJ_LABEL,0,0,0);
ObjectSetText("EURCAD_Trade","Waiting!",10,"Arial",0xff0000);
ObjectCreate("EURCAD_P1",OBJ_LABEL,0,0,0);
ObjectSetText("EURCAD_P1","EUR 0%",10,"Arial",0x777777);
ObjectCreate("EURCAD_P2",OBJ_LABEL,0,0,0);
ObjectSetText("EURCAD_P2","CAD 0%",10,"Arial",0x777777);



Places();
//----
   return(0);
  }
int Places(){
ObjectSet("EURUSD_Title",OBJPROP_XDISTANCE,3);
ObjectSet("EURUSD_Title",OBJPROP_YDISTANCE,10);
ObjectSet("EURUSD_MA",OBJPROP_XDISTANCE,3);
ObjectSet("EURUSD_MA",OBJPROP_YDISTANCE,40);
ObjectSet("EURUSD_MACD",OBJPROP_XDISTANCE,3);
ObjectSet("EURUSD_MACD",OBJPROP_YDISTANCE,55);
ObjectSet("EURUSD_Trade",OBJPROP_XDISTANCE,3);
ObjectSet("EURUSD_Trade",OBJPROP_YDISTANCE,70);
ObjectSet("EURUSD_P1",OBJPROP_XDISTANCE,3);
ObjectSet("EURUSD_P1",OBJPROP_YDISTANCE,85);
ObjectSet("EURUSD_P2",OBJPROP_XDISTANCE,3);
ObjectSet("EURUSD_P2",OBJPROP_YDISTANCE,100);

ObjectSet("GBPUSD_Title",OBJPROP_XDISTANCE,123);
ObjectSet("GBPUSD_Title",OBJPROP_YDISTANCE,10);
ObjectSet("GBPUSD_MA",OBJPROP_XDISTANCE,123);
ObjectSet("GBPUSD_MA",OBJPROP_YDISTANCE,40);
ObjectSet("GBPUSD_MACD",OBJPROP_XDISTANCE,123);
ObjectSet("GBPUSD_MACD",OBJPROP_YDISTANCE,55);
ObjectSet("GBPUSD_Trade",OBJPROP_XDISTANCE,123);
ObjectSet("GBPUSD_Trade",OBJPROP_YDISTANCE,70);
ObjectSet("GBPUSD_P1",OBJPROP_XDISTANCE,123);
ObjectSet("GBPUSD_P1",OBJPROP_YDISTANCE,85);
ObjectSet("GBPUSD_P2",OBJPROP_XDISTANCE,123);
ObjectSet("GBPUSD_P2",OBJPROP_YDISTANCE,100);

ObjectSet("EURCHF_Title",OBJPROP_XDISTANCE,243);
ObjectSet("EURCHF_Title",OBJPROP_YDISTANCE,10);
ObjectSet("EURCHF_MA",OBJPROP_XDISTANCE,243);
ObjectSet("EURCHF_MA",OBJPROP_YDISTANCE,40);
ObjectSet("EURCHF_MACD",OBJPROP_XDISTANCE,243);
ObjectSet("EURCHF_MACD",OBJPROP_YDISTANCE,55);
ObjectSet("EURCHF_Trade",OBJPROP_XDISTANCE,243);
ObjectSet("EURCHF_Trade",OBJPROP_YDISTANCE,70);
ObjectSet("EURCHF_P1",OBJPROP_XDISTANCE,243);
ObjectSet("EURCHF_P1",OBJPROP_YDISTANCE,85);
ObjectSet("EURCHF_P2",OBJPROP_XDISTANCE,243);
ObjectSet("EURCHF_P2",OBJPROP_YDISTANCE,100);

ObjectSet("EURJPY_Title",OBJPROP_XDISTANCE,363);
ObjectSet("EURJPY_Title",OBJPROP_YDISTANCE,10);
ObjectSet("EURJPY_MA",OBJPROP_XDISTANCE,363);
ObjectSet("EURJPY_MA",OBJPROP_YDISTANCE,40);
ObjectSet("EURJPY_MACD",OBJPROP_XDISTANCE,363);
ObjectSet("EURJPY_MACD",OBJPROP_YDISTANCE,55);
ObjectSet("EURJPY_Trade",OBJPROP_XDISTANCE,363);
ObjectSet("EURJPY_Trade",OBJPROP_YDISTANCE,70);
ObjectSet("EURJPY_P1",OBJPROP_XDISTANCE,363);
ObjectSet("EURJPY_P1",OBJPROP_YDISTANCE,85);
ObjectSet("EURJPY_P2",OBJPROP_XDISTANCE,363);
ObjectSet("EURJPY_P2",OBJPROP_YDISTANCE,100);

ObjectSet("USDCHF_Title",OBJPROP_XDISTANCE,483);
ObjectSet("USDCHF_Title",OBJPROP_YDISTANCE,10);
ObjectSet("USDCHF_MA",OBJPROP_XDISTANCE,483);
ObjectSet("USDCHF_MA",OBJPROP_YDISTANCE,40);
ObjectSet("USDCHF_MACD",OBJPROP_XDISTANCE,483);
ObjectSet("USDCHF_MACD",OBJPROP_YDISTANCE,55);
ObjectSet("USDCHF_Trade",OBJPROP_XDISTANCE,483);
ObjectSet("USDCHF_Trade",OBJPROP_YDISTANCE,70);
ObjectSet("USDCHF_P1",OBJPROP_XDISTANCE,483);
ObjectSet("USDCHF_P1",OBJPROP_YDISTANCE,85);
ObjectSet("USDCHF_P2",OBJPROP_XDISTANCE,483);
ObjectSet("USDCHF_P2",OBJPROP_YDISTANCE,100);

ObjectSet("USDJPY_Title",OBJPROP_XDISTANCE,603);
ObjectSet("USDJPY_Title",OBJPROP_YDISTANCE,10);
ObjectSet("USDJPY_MA",OBJPROP_XDISTANCE,603);
ObjectSet("USDJPY_MA",OBJPROP_YDISTANCE,40);
ObjectSet("USDJPY_MACD",OBJPROP_XDISTANCE,603);
ObjectSet("USDJPY_MACD",OBJPROP_YDISTANCE,55);
ObjectSet("USDJPY_Trade",OBJPROP_XDISTANCE,603);
ObjectSet("USDJPY_Trade",OBJPROP_YDISTANCE,70);
ObjectSet("USDJPY_P1",OBJPROP_XDISTANCE,603);
ObjectSet("USDJPY_P1",OBJPROP_YDISTANCE,85);
ObjectSet("USDJPY_P2",OBJPROP_XDISTANCE,603);
ObjectSet("USDJPY_P2",OBJPROP_YDISTANCE,100);

ObjectSet("USDCAD_Title",OBJPROP_XDISTANCE,723);
ObjectSet("USDCAD_Title",OBJPROP_YDISTANCE,10);
ObjectSet("USDCAD_MA",OBJPROP_XDISTANCE,723);
ObjectSet("USDCAD_MA",OBJPROP_YDISTANCE,40);
ObjectSet("USDCAD_MACD",OBJPROP_XDISTANCE,723);
ObjectSet("USDCAD_MACD",OBJPROP_YDISTANCE,55);
ObjectSet("USDCAD_Trade",OBJPROP_XDISTANCE,723);
ObjectSet("USDCAD_Trade",OBJPROP_YDISTANCE,70);
ObjectSet("USDCAD_P1",OBJPROP_XDISTANCE,723);
ObjectSet("USDCAD_P1",OBJPROP_YDISTANCE,85);
ObjectSet("USDCAD_P2",OBJPROP_XDISTANCE,723);
ObjectSet("USDCAD_P2",OBJPROP_YDISTANCE,100);

ObjectSet("EURAUD_Title",OBJPROP_XDISTANCE,843);
ObjectSet("EURAUD_Title",OBJPROP_YDISTANCE,10);
ObjectSet("EURAUD_MA",OBJPROP_XDISTANCE,843);
ObjectSet("EURAUD_MA",OBJPROP_YDISTANCE,40);
ObjectSet("EURAUD_MACD",OBJPROP_XDISTANCE,843);
ObjectSet("EURAUD_MACD",OBJPROP_YDISTANCE,55);
ObjectSet("EURAUD_Trade",OBJPROP_XDISTANCE,843);
ObjectSet("EURAUD_Trade",OBJPROP_YDISTANCE,70);
ObjectSet("EURAUD_P1",OBJPROP_XDISTANCE,843);
ObjectSet("EURAUD_P1",OBJPROP_YDISTANCE,85);
ObjectSet("EURAUD_P2",OBJPROP_XDISTANCE,843);
ObjectSet("EURAUD_P2",OBJPROP_YDISTANCE,100);
/******************************/
ObjectSet("EURGBP_Title",OBJPROP_XDISTANCE,3);
ObjectSet("EURGBP_Title",OBJPROP_YDISTANCE,120);
ObjectSet("EURGBP_MA",OBJPROP_XDISTANCE,3);
ObjectSet("EURGBP_MA",OBJPROP_YDISTANCE,150);
ObjectSet("EURGBP_MACD",OBJPROP_XDISTANCE,3);
ObjectSet("EURGBP_MACD",OBJPROP_YDISTANCE,165);
ObjectSet("EURGBP_Trade",OBJPROP_XDISTANCE,3);
ObjectSet("EURGBP_Trade",OBJPROP_YDISTANCE,180);
ObjectSet("EURGBP_P1",OBJPROP_XDISTANCE,3);
ObjectSet("EURGBP_P1",OBJPROP_YDISTANCE,195);
ObjectSet("EURGBP_P2",OBJPROP_XDISTANCE,3);
ObjectSet("EURGBP_P2",OBJPROP_YDISTANCE,210);

ObjectSet("AUDUSD_Title",OBJPROP_XDISTANCE,123);
ObjectSet("AUDUSD_Title",OBJPROP_YDISTANCE,120);
ObjectSet("AUDUSD_MA",OBJPROP_XDISTANCE,123);
ObjectSet("AUDUSD_MA",OBJPROP_YDISTANCE,150);
ObjectSet("AUDUSD_MACD",OBJPROP_XDISTANCE,123);
ObjectSet("AUDUSD_MACD",OBJPROP_YDISTANCE,165);
ObjectSet("AUDUSD_Trade",OBJPROP_XDISTANCE,123);
ObjectSet("AUDUSD_Trade",OBJPROP_YDISTANCE,180);
ObjectSet("AUDUSD_P1",OBJPROP_XDISTANCE,123);
ObjectSet("AUDUSD_P1",OBJPROP_YDISTANCE,195);
ObjectSet("AUDUSD_P2",OBJPROP_XDISTANCE,123);
ObjectSet("AUDUSD_P2",OBJPROP_YDISTANCE,210);

ObjectSet("GBPCHF_Title",OBJPROP_XDISTANCE,243);
ObjectSet("GBPCHF_Title",OBJPROP_YDISTANCE,120);
ObjectSet("GBPCHF_MA",OBJPROP_XDISTANCE,243);
ObjectSet("GBPCHF_MA",OBJPROP_YDISTANCE,150);
ObjectSet("GBPCHF_MACD",OBJPROP_XDISTANCE,243);
ObjectSet("GBPCHF_MACD",OBJPROP_YDISTANCE,165);
ObjectSet("GBPCHF_Trade",OBJPROP_XDISTANCE,243);
ObjectSet("GBPCHF_Trade",OBJPROP_YDISTANCE,180);
ObjectSet("GBPCHF_P1",OBJPROP_XDISTANCE,243);
ObjectSet("GBPCHF_P1",OBJPROP_YDISTANCE,195);
ObjectSet("GBPCHF_P2",OBJPROP_XDISTANCE,243);
ObjectSet("GBPCHF_P2",OBJPROP_YDISTANCE,210);

ObjectSet("GBPJPY_Title",OBJPROP_XDISTANCE,363);
ObjectSet("GBPJPY_Title",OBJPROP_YDISTANCE,120);
ObjectSet("GBPJPY_MA",OBJPROP_XDISTANCE,363);
ObjectSet("GBPJPY_MA",OBJPROP_YDISTANCE,150);
ObjectSet("GBPJPY_MACD",OBJPROP_XDISTANCE,363);
ObjectSet("GBPJPY_MACD",OBJPROP_YDISTANCE,165);
ObjectSet("GBPJPY_Trade",OBJPROP_XDISTANCE,363);
ObjectSet("GBPJPY_Trade",OBJPROP_YDISTANCE,180);
ObjectSet("GBPJPY_P1",OBJPROP_XDISTANCE,363);
ObjectSet("GBPJPY_P1",OBJPROP_YDISTANCE,195);
ObjectSet("GBPJPY_P2",OBJPROP_XDISTANCE,363);
ObjectSet("GBPJPY_P2",OBJPROP_YDISTANCE,210);

ObjectSet("AUDCHF_Title",OBJPROP_XDISTANCE,483);
ObjectSet("AUDCHF_Title",OBJPROP_YDISTANCE,120);
ObjectSet("AUDCHF_MA",OBJPROP_XDISTANCE,483);
ObjectSet("AUDCHF_MA",OBJPROP_YDISTANCE,150);
ObjectSet("AUDCHF_MACD",OBJPROP_XDISTANCE,483);
ObjectSet("AUDCHF_MACD",OBJPROP_YDISTANCE,165);
ObjectSet("AUDCHF_Trade",OBJPROP_XDISTANCE,483);
ObjectSet("AUDCHF_Trade",OBJPROP_YDISTANCE,180);
ObjectSet("AUDCHF_P1",OBJPROP_XDISTANCE,483);
ObjectSet("AUDCHF_P1",OBJPROP_YDISTANCE,195);
ObjectSet("AUDCHF_P2",OBJPROP_XDISTANCE,483);
ObjectSet("AUDCHF_P2",OBJPROP_YDISTANCE,210);

ObjectSet("AUDCAD_Title",OBJPROP_XDISTANCE,603);
ObjectSet("AUDCAD_Title",OBJPROP_YDISTANCE,120);
ObjectSet("AUDCAD_MA",OBJPROP_XDISTANCE,603);
ObjectSet("AUDCAD_MA",OBJPROP_YDISTANCE,150);
ObjectSet("AUDCAD_MACD",OBJPROP_XDISTANCE,603);
ObjectSet("AUDCAD_MACD",OBJPROP_YDISTANCE,165);
ObjectSet("AUDCAD_Trade",OBJPROP_XDISTANCE,603);
ObjectSet("AUDCAD_Trade",OBJPROP_YDISTANCE,180);
ObjectSet("AUDCAD_P1",OBJPROP_XDISTANCE,603);
ObjectSet("AUDCAD_P1",OBJPROP_YDISTANCE,195);
ObjectSet("AUDCAD_P2",OBJPROP_XDISTANCE,603);
ObjectSet("AUDCAD_P2",OBJPROP_YDISTANCE,210);

ObjectSet("AUDJPY_Title",OBJPROP_XDISTANCE,723);
ObjectSet("AUDJPY_Title",OBJPROP_YDISTANCE,120);
ObjectSet("AUDJPY_MA",OBJPROP_XDISTANCE,723);
ObjectSet("AUDJPY_MA",OBJPROP_YDISTANCE,150);
ObjectSet("AUDJPY_MACD",OBJPROP_XDISTANCE,723);
ObjectSet("AUDJPY_MACD",OBJPROP_YDISTANCE,165);
ObjectSet("AUDJPY_Trade",OBJPROP_XDISTANCE,723);
ObjectSet("AUDJPY_Trade",OBJPROP_YDISTANCE,180);
ObjectSet("AUDJPY_P1",OBJPROP_XDISTANCE,723);
ObjectSet("AUDJPY_P1",OBJPROP_YDISTANCE,195);
ObjectSet("AUDJPY_P2",OBJPROP_XDISTANCE,723);
ObjectSet("AUDJPY_P2",OBJPROP_YDISTANCE,210);

ObjectSet("EURCAD_Title",OBJPROP_XDISTANCE,843);
ObjectSet("EURCAD_Title",OBJPROP_YDISTANCE,120);
ObjectSet("EURCAD_MA",OBJPROP_XDISTANCE,843);
ObjectSet("EURCAD_MA",OBJPROP_YDISTANCE,150);
ObjectSet("EURCAD_MACD",OBJPROP_XDISTANCE,843);
ObjectSet("EURCAD_MACD",OBJPROP_YDISTANCE,165);
ObjectSet("EURCAD_Trade",OBJPROP_XDISTANCE,843);
ObjectSet("EURCAD_Trade",OBJPROP_YDISTANCE,180);
ObjectSet("EURCAD_P1",OBJPROP_XDISTANCE,843);
ObjectSet("EURCAD_P1",OBJPROP_YDISTANCE,195);
ObjectSet("EURCAD_P2",OBJPROP_XDISTANCE,843);
ObjectSet("EURCAD_P2",OBJPROP_YDISTANCE,210);

}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   EUR=PowerEUR(0);
   USD=PowerUSD(0);
   GBP=PowerGBP(0);
   CHF=PowerCHF(0);
   JPY=PowerJPY(0);
   CAD=PowerCAD(0);
   AUD=PowerAUD(0);
   
   tx=EUR;
   if(tx<0) col=Red;
   if(tx>0) col=Green;
   if(tx==0) col=0x777777;
   ObjectSetText("EURUSD_P1","EUR "+DoubleToStr(tx,0)+"%",10,"Arial",col);
   tx=USD;
   if(tx<0) col=Red;
   if(tx>0) col=Green;
   if(tx==0) col=0x777777;
   ObjectSetText("EURUSD_P2","USD "+DoubleToStr(tx,0)+"%",10,"Arial",col);
   
tx=GBP;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("GBPUSD_P1","GBP "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=USD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("GBPUSD_P2","USD "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=EUR;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("EURCHF_P1","EUR "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=CHF;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("EURCHF_P2","CHF "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=EUR;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("EURJPY_P1","EUR "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=JPY;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("EURJPY_P2","JPY "+DoubleToStr(tx,0)+"%",10,"Arial",col);
   
tx=USD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("USDCHF_P1","USD "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=CHF;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("USDCHF_P2","CHF "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=USD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("USDJPY_P1","USD "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=JPY;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("USDJPY_P2","JPY "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=USD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("USDCAD_P1","USD "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=CAD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("USDCAD_P2","CAD "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=EUR;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("EURAUD_P1","EUR "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=AUD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("EURAUD_P2","AUD "+DoubleToStr(tx,0)+"%",10,"Arial",col);
   
tx=EUR;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("EURGBP_P1","EUR "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=GBP;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("EURGBP_P2","GBP "+DoubleToStr(tx,0)+"%",10,"Arial",col);
   
tx=AUD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("AUDUSD_P1","AUD "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=USD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("AUDUSD_P2","USD "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=GBP;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("GBPCHF_P1","GBP "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=CHF;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("GBPCHF_P2","CHF "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=GBP;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("GBPJPY_P1","GBP "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=JPY;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("GBPJPY_P2","JPY "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=AUD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("AUDCHF_P1","AUD "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=CHF;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("AUDCHF_P2","CHF "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=AUD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("AUDCAD_P1","AUD "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=CAD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("AUDCAD_P2","CAD "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=AUD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("AUDJPY_P1","AUD "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=JPY;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("AUDJPY_P2","JPY "+DoubleToStr(tx,0)+"%",10,"Arial",col);

tx=EUR;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("EURCAD_P1","EUR "+DoubleToStr(tx,0)+"%",10,"Arial",col);
tx=CAD;if(tx<0) col=Red;if(tx>0) col=Green;if(tx==0) col=0x777777;
ObjectSetText("EURCAD_P2","CAD "+DoubleToStr(tx,0)+"%",10,"Arial",col);

   
   Places();
   if(BarTime!=Time[0]){
   BarTime=Time[0];
   once();
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+
int once(){
   /****************/
   trend("EURUSD");
   trend("GBPUSD");
   trend("EURCHF");
   trend("EURJPY");
   trend("USDCHF");
   trend("USDJPY");
   trend("USDCAD");
   trend("EURAUD");
   
   trend("EURGBP");
   trend("AUDUSD");
   trend("GBPCHF");
   trend("GBPJPY");
   trend("AUDCHF");
   trend("AUDCAD");
   trend("AUDJPY");
   trend("EURCAD");
   
   /****************/
   }
int MA_Trend(string sym, int shift){
   double ma1=iMA(sym,0,MaPeriod1,0,MODE_EMA,PRICE_CLOSE,shift);
   double ma2=iMA(sym,0,MaPeriod2,0,MODE_LWMA,PRICE_LOW,shift);
   double ma3=iMA(sym,0,MaPeriod3,0,MODE_LWMA,PRICE_LOW,shift);
   if(ma1>ma2 && ma1>ma3)  
     {
      return(1);
     }       
//---- sell   
else if(ma1<ma2 && ma1<ma3)  
     {
      return(-1);
     }
else return(0);
//-
   }
int MACD_Trend(string sym, int shift){
   double macd=iMACD(sym,0,MacdFast,MacdSlow,1,PRICE_CLOSE,MODE_MAIN,shift);
   if(macd>0) return(1);
   if(macd<0) return(-1);
   if(macd==0) return(0);
   }
int trend(string sym){
   int MA=MA_Trend(sym,1);
   int MACD=MACD_Trend(sym,1);
   XMA=GET_XMA(sym,1);
   if(MA==1) ObjectSetText(sym+"_MA","MA is UP!",10,"Arial",Green);
   if(MA==-1) ObjectSetText(sym+"_MA","MA is DOWN!",10,"Arial",Red);
   if(MA==0) ObjectSetText(sym+"_MA","MA NONE!",10,"Arial",0x777777);
   if(MACD==1) ObjectSetText(sym+"_MACD","MACD is UP!",10,"Arial",Green);
   if(MACD==-1) ObjectSetText(sym+"_MACD","MACD is DOWN!",10,"Arial",Red);
   if(MACD==0) ObjectSetText(sym+"_MACD","MACD NONE!",10,"Arial",0x777777);
   if(XMA==1) ObjectSetText(sym+"_Trade","Buying!",10,"Arial",Blue);
   if(XMA==-1) ObjectSetText(sym+"_Trade","Selling!",10,"Arial",Blue);
   if(XMA==0) ObjectSetText(sym+"_Trade","Waiting!",10,"Arial",Blue);
if(GET_XMA(sym,1)!=GET_XMA(sym,2)){
   if(GET_XMA(sym,1)==1){
      Alert(sym+" Buying!");
      }
   if(GET_XMA(sym,1)==-1){
      Alert(sym+" Selling!");
      }
   if(GET_XMA(sym,1)==0){
      Alert(sym+" Closing!");
      }
   }
}
int GET_XMA(string sym,int shift){
   if(MA_Trend(sym,shift)==1 && MACD_Trend(sym,shift)==1) return(1);
   else if(MA_Trend(sym,shift)==-1 && MACD_Trend(sym,shift)==-1) return(-1);
   else return(0);
   }
double PowerEUR(int shift){
   double res=0;
   double step=100/9;
   res+=GET_XMA("EURCHF",shift)*step;
   res+=GET_XMA("EURJPY",shift)*step;
   res+=GET_XMA("EURAUD",shift)*step;
   res+=GET_XMA("EURGBP",shift)*step;
   res+=GET_XMA("EURCAD",shift)*step;
   res+=GET_XMA("EURNZD",shift)*step;
   res+=GET_XMA("EURSGD",shift)*step;
   res+=GET_XMA("EURUSD",shift)*step;
   return(res);
   }
double PowerUSD(int shift){
   double res=0;
   double step=100/9;
   res+=GET_XMA("USDCHF",shift)*step;
   res+=GET_XMA("USDJPY",shift)*step;
   res+=GET_XMA("AUDUSD",shift)*step*(-1);
   res+=GET_XMA("GBPUSD",shift)*step*(-1);
   res+=GET_XMA("USDCAD",shift)*step;
   res+=GET_XMA("NZDUSD",shift)*step*(-1);
   res+=GET_XMA("USDSGD",shift)*step;
   res+=GET_XMA("EURUSD",shift)*step*(-1);
   return(res);
   }
double PowerGBP(int shift){
   double res=0;
   double step=100/7;
   res+=GET_XMA("GBPUSD",shift)*step;
   res+=GET_XMA("EURGBP",shift)*step*(-1);
   res+=GET_XMA("GBPJPY",shift)*step;
   res+=GET_XMA("GBPCHF",shift)*step;
   res+=GET_XMA("GBPAUD",shift)*step;
   res+=GET_XMA("GBPCAD",shift)*step;
   res+=GET_XMA("GBPSGD",shift)*step;
   return(res);
   }
double PowerCHF(int shift){
   double res=0;
   double step=100/6;
   res+=GET_XMA("USDCHF",shift)*step*(-1);
   res+=GET_XMA("EURCHF",shift)*step*(-1);
   res+=GET_XMA("GBPCHF",shift)*step*(-1);
   res+=GET_XMA("AUDCHF",shift)*step*(-1);
   res+=GET_XMA("CADCHF",shift)*step*(-1);
   res+=GET_XMA("NZDCHF",shift)*step*(-1);
   return(res);
   }
double PowerJPY(int shift){
   double res=0;
   double step=100/8;
   res+=GET_XMA("USDJPY",shift)*step*(-1);
   res+=GET_XMA("EURJPY",shift)*step*(-1);
   res+=GET_XMA("GBPJPY",shift)*step*(-1);
   res+=GET_XMA("AUDJPY",shift)*step*(-1);
   res+=GET_XMA("CHFJPY",shift)*step*(-1);
   res+=GET_XMA("CADJPY",shift)*step*(-1);
   res+=GET_XMA("NZDJPY",shift)*step*(-1);
   res+=GET_XMA("SGDJPY",shift)*step*(-1);
   return(res);
   }
double PowerCAD(int shift){
   double res=0;
   double step=100/7;
   res+=GET_XMA("USDCAD",shift)*step*(-1);
   res+=GET_XMA("AUDCAD",shift)*step*(-1);
   res+=GET_XMA("CADCHF",shift)*step;
   res+=GET_XMA("CADJPY",shift)*step;
   res+=GET_XMA("EURCAD",shift)*step*(-1);
   res+=GET_XMA("GBPCAD",shift)*step*(-1);
   res+=GET_XMA("NZDCAD",shift)*step*(-1);
   return(res);
   }
double PowerAUD(int shift){
   double res=0;
   double step=100/8;
   res+=GET_XMA("AUDUSD",shift)*step;
   res+=GET_XMA("EURAUD",shift)*step*(-1);
   res+=GET_XMA("AUDCAD",shift)*step;
   res+=GET_XMA("AUDCHF",shift)*step;
   res+=GET_XMA("AUDJPY",shift)*step;
   res+=GET_XMA("AUDNZD",shift)*step;
   res+=GET_XMA("AUDSGD",shift)*step;
   res+=GET_XMA("GBPAUD",shift)*step*(-1);
   return(res);
   }

