//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Green

double CrossUp[];
double CrossDown[];

extern int FastEMA=12;
extern int SlowEMA=26;
extern double buffersize = 20; //

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 159);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 159);
   SetIndexBuffer(1, CrossDown);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int counter;
   
   double Range, AvgRange;
   double MA_F, MA_S, MA_F1, MA_S1;
   
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
   for (int i = 0; i <= limit; i++) 
   {   
      counter = i;
      Range = 0;
      AvgRange = 0;
      CrossUp[i] = 0;
      CrossDown[i] = 0;
      for (counter = i; counter <= i + 9; counter++) 
      AvgRange += MathAbs(High[counter] - Low[counter]);

      Range = AvgRange / 10;
//+------------------------------------------------------------------+      
      MA_F = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i);
      MA_F1 = iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i+1);
      MA_S = iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
      MA_S1 = iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i+1);
     
//+------------------------------------------------------------------+      
      if (
      MA_S1 - MA_F1 < buffersize*Point
      && MA_F - MA_S < buffersize*Point
      && MA_F - MA_S < -buffersize*Point
      ) {
         CrossUp[i] = Low[i] - Range*0.5;
      }
//+------------------------------------------------------------------+     
      else if (
      MA_S1 - MA_F1 > -buffersize*Point
      && MA_F - MA_S > buffersize*Point
      && MA_F - MA_S > -buffersize*Point
      ) {
         CrossDown[i] = High[i] + Range*0.5;
      }
//+------------------------------------------------------------------+     
   }
   return(0);
}

//--- .  .  
//      if (
//      MA_S1 < MA_F1
//      && MA_F < MA_S
//      ) {
//         CrossUp[i] = Low[i] - Range*0.5;
//      }
//+------------------------------------------------------------------+     
//      else if (
//      MA_S1 > MA_F1
//      && MA_F > MA_S
//      ) {
//         CrossDown[i] = High[i] + Range*0.5;
//      }
//+------------------------------------------------------------------+     
//   }
//   return(0);
//}