#property copyright "Copyright  2004, Mr KAY Software"
#property link      ""

#property indicator_separate_window
#property indicator_levelcolor Gray
#property indicator_levelstyle 0
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Fuchsia
#property indicator_color3 Yellow
#property indicator_color4 Goldenrod
#property indicator_color5 Blue
#property indicator_color6 Aqua
#property indicator_color7 Lime
#property indicator_color8 Red

int Gl_timeframe_76 = PERIOD_M1;
int Gl_timeframe_80 = PERIOD_M5;
int Gli_84 = 15;
int Gli_88 = 30;
int Gli_92 = 60;
int Gli_96 = 240;
int Gli_100 = 1440;
int Gli_104 = 10080;
int Gli_108 = 43200;
extern string MACD_Setting = "Enter Period for Fast, Slow & Signal";
extern int fastMA = 12;
extern int SlowMA = 26;
extern int SignalPeriod = 9;
extern string Display = "Text Location";
extern int TextDist = 12;
double Gl_ibuf_144[];
double Gl_ibuf_148[];
double Gl_ibuf_152[];
double Gl_ibuf_156[];
double Gl_ibuf_160[];
double Gl_ibuf_164[];
double Gl_ibuf_168[];
double Gl_ibuf_172[];
int Gl_period_176;
string Gls_180;

int init() {
   if (Period() == Gl_timeframe_76) {
      Gl_timeframe_76 = Period();
      Gl_period_176 = Gl_timeframe_80;
   }
   if (Period() == Gl_timeframe_80) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_84;
      Gl_period_176 = Gli_84 / Period();
   }
   if (Period() == Gli_84) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_88;
      Gl_period_176 = Gli_88 / Period();
   }
   if (Period() == Gli_88) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_92;
      Gl_period_176 = Gli_92 / Period();
   }
   if (Period() == Gli_92) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_96;
      Gl_period_176 = Gli_96 / Period();
   }
   if (Period() == Gli_96) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_100;
      Gl_period_176 = Gli_100 / Period();
   }
   if (Period() == Gli_100) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_104;
      Gl_period_176 = Gli_104 / Period();
   }
   if (Period() == Gli_104) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_108;
      Gl_period_176 = Gli_108 / Period();
   }
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2, Red);
   SetIndexBuffer(0, Gl_ibuf_144);
   SetIndexStyle(1, DRAW_LINE, STYLE_DOT, 0, Fuchsia);
   SetIndexBuffer(1, Gl_ibuf_148);
   SetIndexStyle(2, DRAW_NONE);
   SetIndexBuffer(2, Gl_ibuf_152);
   SetIndexStyle(3, DRAW_NONE);
   SetIndexBuffer(3, Gl_ibuf_156);
   SetIndexStyle(4, DRAW_LINE, STYLE_SOLID, 2, Blue);
   SetIndexBuffer(4, Gl_ibuf_160);
   SetIndexStyle(5, DRAW_LINE, STYLE_DOT, 0, Aqua);
   SetIndexBuffer(5, Gl_ibuf_164);
   SetIndexStyle(6, DRAW_HISTOGRAM, STYLE_SOLID, 3, Lime);
   SetIndexBuffer(6, Gl_ibuf_168);
   SetIndexStyle(7, DRAW_HISTOGRAM, STYLE_SOLID, 3, Red);
   SetIndexBuffer(7, Gl_ibuf_172);
   SetIndexLabel(0, "Main " + Gl_timeframe_76 + "m");
   SetIndexLabel(1, "Signal " + Gl_timeframe_76 + "m");
   SetIndexLabel(2, "Main " + Gl_timeframe_80 + "m");
   SetIndexLabel(3, "Signal " + Gl_timeframe_80 + "m");
   SetIndexLabel(6, "Diff Main to Signal " + Gl_timeframe_80 + "m");
   SetIndexLabel(7, "Diff Main to Signal " + Gl_timeframe_80 + "m");
   IndicatorShortName("KAY Dual TimeFrame_Macd " + Gl_timeframe_76 + "m " + Gl_timeframe_80 + "m ");
   Gls_180 = "KAY Dual TimeFrame_Macd " + Gl_timeframe_76 + "m " + Gl_timeframe_80 + "m ";
   return (0);
}

int deinit() {
   ObjectsDeleteAll();
   return (0);
}

int start() {
   int Lci_0 = IndicatorCounted();
   if (Lci_0 > 0) Lci_0--;
   int Lci_4 = Bars - Lci_0;
   if (Period() == Gl_timeframe_76) {
      Gl_timeframe_76 = Period();
      Gl_period_176 = Gl_timeframe_80;
   }
   if (Period() == Gl_timeframe_80) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_84;
      Gl_period_176 = Gli_84 / Period();
   }
   if (Period() == Gli_84) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_88;
      Gl_period_176 = Gli_88 / Period();
   }
   if (Period() == Gli_88) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_92;
      Gl_period_176 = Gli_92 / Period();
   }
   if (Period() == Gli_92) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_96;
      Gl_period_176 = Gli_96 / Period();
   }
   if (Period() == Gli_96) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_100;
      Gl_period_176 = Gli_100 / Period();
   }
   if (Period() == Gli_100) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_104;
      Gl_period_176 = Gli_104 / Period();
   }
   if (Period() == Gli_104) {
      Gl_timeframe_76 = Period();
      Gl_timeframe_80 = Gli_108;
      Gl_period_176 = Gli_108 / Period();
   }
   for (int Lci_8 = Lci_4; Lci_8 >= 0; Lci_8--) {
      Gl_ibuf_144[Lci_8] = iMACD(NULL, Gl_timeframe_76, fastMA, SlowMA, SignalPeriod, PRICE_CLOSE, MODE_MAIN, iBarShift(NULL, Gl_timeframe_76, Time[Lci_8]));
      Gl_ibuf_148[Lci_8] = iMACD(NULL, Gl_timeframe_76, fastMA, SlowMA, SignalPeriod, PRICE_CLOSE, MODE_SIGNAL, iBarShift(NULL, Gl_timeframe_76, Time[Lci_8]));
      Gl_ibuf_152[Lci_8] = iMACD(NULL, Gl_timeframe_80, fastMA, SlowMA, SignalPeriod, PRICE_CLOSE, MODE_MAIN, iBarShift(NULL, Gl_timeframe_80, Time[Lci_8]));
      Gl_ibuf_156[Lci_8] = iMACD(NULL, Gl_timeframe_80, fastMA, SlowMA, SignalPeriod, PRICE_CLOSE, MODE_SIGNAL, iBarShift(NULL, Gl_timeframe_80, Time[Lci_8]));
   }
   for (Lci_8 = Lci_4; Lci_8 >= 0; Lci_8--) {
      Gl_ibuf_160[Lci_8] = iMAOnArray(Gl_ibuf_152, 0, Gl_period_176, 0, MODE_SMA, Lci_8);
      Gl_ibuf_164[Lci_8] = iMAOnArray(Gl_ibuf_156, 0, Gl_period_176, 0, MODE_SMA, Lci_8);
      if (Gl_ibuf_160[Lci_8] - Gl_ibuf_164[Lci_8] >= Gl_ibuf_160[Lci_8 + 1] - (Gl_ibuf_164[Lci_8 + 1])) {
         Gl_ibuf_168[Lci_8] = Gl_ibuf_160[Lci_8] - Gl_ibuf_164[Lci_8];
         Gl_ibuf_172[Lci_8] = 0.0;
      } else {
         Gl_ibuf_172[Lci_8] = Gl_ibuf_160[Lci_8] - Gl_ibuf_164[Lci_8];
         Gl_ibuf_168[Lci_8] = 0.0;
      }
   }
   if (iMACD(NULL, Gl_timeframe_76, fastMA, SlowMA, SignalPeriod, PRICE_CLOSE, MODE_MAIN, iBarShift(NULL, Gl_timeframe_76, Time[0])) >= iMACD(NULL, Gl_timeframe_76,
      fastMA, SlowMA, SignalPeriod, PRICE_CLOSE, MODE_SIGNAL, iBarShift(NULL, Gl_timeframe_76, Time[0]))) {
      Arrow("Macd" + Gl_timeframe_76 + "m", Time[0] + 60 * Period() * 2, WindowPriceMin(WindowFind(Gls_180)) + 0.8 * (WindowPriceMax(WindowFind(Gls_180)) - WindowPriceMin(WindowFind(Gls_180))),
         233, 2, Red);
      Text("Macd_TF_" + Gl_timeframe_76 + "m", Time[0] + 60 * Period() * TextDist, WindowPriceMin(WindowFind(Gls_180)) + 0.8 * (WindowPriceMax(WindowFind(Gls_180)) - WindowPriceMin(WindowFind(Gls_180))),
         10, Red);
   } else {
      Arrow("Macd" + Gl_timeframe_76 + "m", Time[0] + 60 * Period() * 2, WindowPriceMin(WindowFind(Gls_180)) + 0.8 * (WindowPriceMax(WindowFind(Gls_180)) - WindowPriceMin(WindowFind(Gls_180))),
         234, 2, Red);
      Text("Macd_TF_" + Gl_timeframe_76 + "m", Time[0] + 60 * Period() * TextDist, WindowPriceMin(WindowFind(Gls_180)) + 0.8 * (WindowPriceMax(WindowFind(Gls_180)) - WindowPriceMin(WindowFind(Gls_180))),
         10, Red);
   }
   if (iMACD(NULL, Gl_timeframe_80, fastMA, SlowMA, SignalPeriod, PRICE_CLOSE, MODE_MAIN, iBarShift(NULL, Gl_timeframe_80, Time[0])) >= iMACD(NULL, Gl_timeframe_80,
      fastMA, SlowMA, SignalPeriod, PRICE_CLOSE, MODE_SIGNAL, iBarShift(NULL, Gl_timeframe_80, Time[0]))) {
      Arrow("Macd" + Gl_timeframe_80 + "m", Time[0] + 60 * Period() * 2, WindowPriceMin(WindowFind(Gls_180)) + 0.6 * (WindowPriceMax(WindowFind(Gls_180)) - WindowPriceMin(WindowFind(Gls_180))),
         233, 2, Blue);
      Text("Macd_TF_" + Gl_timeframe_80 + "m", Time[0] + 60 * Period() * TextDist, WindowPriceMin(WindowFind(Gls_180)) + 0.6 * (WindowPriceMax(WindowFind(Gls_180)) - WindowPriceMin(WindowFind(Gls_180))),
         10, Blue);
   } else {
      Arrow("Macd" + Gl_timeframe_80 + "m", Time[0] + 60 * Period() * 2, WindowPriceMin(WindowFind(Gls_180)) + 0.6 * (WindowPriceMax(WindowFind(Gls_180)) - WindowPriceMin(WindowFind(Gls_180))),
         234, 2, Blue);
      Text("Macd_TF_" + Gl_timeframe_80 + "m", Time[0] + 60 * Period() * TextDist, WindowPriceMin(WindowFind(Gls_180)) + 0.6 * (WindowPriceMax(WindowFind(Gls_180)) - WindowPriceMin(WindowFind(Gls_180))),
         10, Blue);
   }
   return (0);
}

double Arrow(string Ar_name_0, int Ar_datetime_8, double Ar_price_12, int Ari_20, int Ar_width_24, color Ar_color_28) {
   double Lcd_ret_32 = ObjectCreate(Ar_name_0, OBJ_ARROW, WindowFind(Gls_180), Ar_datetime_8, Ar_price_12);
   ObjectSet(Ar_name_0, OBJPROP_TIME1, Ar_datetime_8);
   ObjectSet(Ar_name_0, OBJPROP_PRICE1, Ar_price_12);
   ObjectSet(Ar_name_0, OBJPROP_ARROWCODE, Ari_20);
   ObjectSet(Ar_name_0, OBJPROP_WIDTH, Ar_width_24);
   ObjectSet(Ar_name_0, OBJPROP_COLOR, Ar_color_28);
   return (Lcd_ret_32);
}

double Text(string Ar_name_0, int Ar_datetime_8, double Ar_price_12, int Ar_fontsize_20, color Ar_color_24) {
   double Lcd_ret_28 = ObjectCreate(Ar_name_0, OBJ_TEXT, WindowFind(Gls_180), Ar_datetime_8, Ar_price_12);
   ObjectSet(Ar_name_0, OBJPROP_TIME1, Ar_datetime_8);
   ObjectSet(Ar_name_0, OBJPROP_PRICE1, Ar_price_12);
   ObjectSetText(Ar_name_0, "" + Ar_name_0, Ar_fontsize_20, "verdana", Ar_color_24);
   return (Lcd_ret_28);
}