//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Orange
#property indicator_width1  2

//
//
//
//
//

extern int FastEma1 = 12;
extern int SlowEma1 = 26;
extern int Price1   = PRICE_CLOSE;
extern int FastEma2 = 24;
extern int SlowEma2 = 52;
extern int Price2   = PRICE_CLOSE;
extern int FastEma3 = 0;
extern int SlowEma3 = 0;
extern int Price3   = PRICE_CLOSE;
extern int FastEma4 = 0;
extern int SlowEma4 = 0;
extern int Price4   = PRICE_CLOSE;
extern int FastEma5 = 0;
extern int SlowEma5 = 0;
extern int Price5   = PRICE_CLOSE;
extern int FastEma6 = 0;
extern int SlowEma6 = 0;
extern int Price6   = PRICE_CLOSE;
extern int FastEma7 = 0;
extern int SlowEma7 = 0;
extern int Price7   = PRICE_CLOSE;
extern int FastEma8 = 0;
extern int SlowEma8 = 0;
extern int Price8   = PRICE_CLOSE;
double macd[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,macd);
   IndicatorShortName("MACD - composite");
   return(0);
}
int deinit(){ return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

 	for(int i = limit; i>=0; i--)
 	{
 	    macd[i] = 0;
 	    if (FastEma1>0 && SlowEma1>0) macd[i] += iMACD(NULL,0,FastEma1,SlowEma1,1,Price1,MODE_MAIN,i);
 	    if (FastEma2>0 && SlowEma2>0) macd[i] += iMACD(NULL,0,FastEma2,SlowEma2,1,Price2,MODE_MAIN,i);
 	    if (FastEma3>0 && SlowEma3>0) macd[i] += iMACD(NULL,0,FastEma3,SlowEma3,1,Price3,MODE_MAIN,i);
 	    if (FastEma4>0 && SlowEma4>0) macd[i] += iMACD(NULL,0,FastEma4,SlowEma4,1,Price4,MODE_MAIN,i);
 	    if (FastEma5>0 && SlowEma5>0) macd[i] += iMACD(NULL,0,FastEma5,SlowEma5,1,Price5,MODE_MAIN,i);
 	    if (FastEma6>0 && SlowEma6>0) macd[i] += iMACD(NULL,0,FastEma6,SlowEma6,1,Price6,MODE_MAIN,i);
 	    if (FastEma7>0 && SlowEma7>0) macd[i] += iMACD(NULL,0,FastEma7,SlowEma7,1,Price7,MODE_MAIN,i);
 	    if (FastEma8>0 && SlowEma8>0) macd[i] += iMACD(NULL,0,SlowEma8,SlowEma8,1,Price8,MODE_MAIN,i);
   } 	    
   return(0);
}