//+------------------------------------------------------------------+
//|                                          colored macd            |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     Green
#property indicator_color2     Coral
#property indicator_color3     DarkSlateGray
#property indicator_color4     Aqua
#property indicator_color5     Red
#property indicator_width1     3
#property indicator_width2     3
#property indicator_width3     3
#property indicator_width4     1
#property indicator_width5     1
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int    FastMa          = 12;
extern int    FastMa_Method   = 1;
extern int    SlowMa          = 26;
extern int    SlowMa_Method   = 1;
extern int    SignalMa        = 9;
extern int    SignalMa_Method = 1;

//
//
//
//
//

double Upa[];
double Dna[];
double osma[];
double macd[];
double signal[];
double trend[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,Upa);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dna);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,osma);
   SetIndexBuffer(3,signal);
   SetIndexBuffer(4,macd);
   SetIndexBuffer(5,trend);
   SetLevelValue(0,0);
   
   FastMa   = MathMax(FastMa,1);
   SlowMa   = MathMax(SlowMa,1);
   SignalMa = MathMax(SignalMa,1);
      
   IndicatorShortName("MACD  ("+FastMa+","+SlowMa+","+SignalMa+")");
return(0);
}
            
int deinit() { return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
    

   for (i=limit; i>=0; i--) macd[i]   = iMA(NULL,0,FastMa,0,FastMa_Method,PRICE_CLOSE,i) - iMA(NULL,0,SlowMa,0,SlowMa_Method,PRICE_CLOSE,i);
   for (i=limit; i>=0; i--) signal[i] = iMAOnArray(macd,Bars,SignalMa,0,SignalMa_Method,i);
   for (i=limit; i>=0; i--) 
   {
       osma[i]  = macd[i]-signal[i];
       Upa[i]   = EMPTY_VALUE;
       Dna[i]   = EMPTY_VALUE;
       trend[i] = trend[i+1];
         if (osma[i] > 0) trend[i] =  1;
         if (osma[i] < 0) trend[i] = -1;
         if (trend[i]== 1) Upa[i] = osma[i];
         if (trend[i]==-1) Dna[i] = osma[i];
   }     
return(0);           
}

