//+------------------------------------------------------------------+
//|                                               Macd_Histogram.mq4 |
//|                                         Copyright  2010, NADAV. |
//|                                      "qjolqwer At walla dot com" |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, NADAV."
#property link "qjolqwer At walla dot com"

#property indicator_separate_window 
#property indicator_buffers 4

#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Green
               

string    indName="Macd_Hitogram";

//---- buffers
double ExtMapBufGreen[];
double ExtMapBufBlue[];
double ExtMapBufRed[];
double ExtMapBufLime[];

extern double FastEma = 12;
extern double SlowEma = 26;
extern double Signal  = 9;

int FixZeroD=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,2);
   IndicatorDigits(Digits+1);

   SetIndexBuffer(0,ExtMapBufGreen);
   SetIndexBuffer(1,ExtMapBufBlue);
   SetIndexBuffer(2,ExtMapBufRed);
   SetIndexBuffer(3,ExtMapBufLime);



//   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));	   
   
	
   //----
   return(0);
  } 

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()                         
  {
  
   int limit;
   int counted_bars=IndicatorCounted();
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
             
//  while(i>=0)                      
//    {
   for(int i=0; i<limit; i++)
 
    ExtMapBufGreen[i] = iMA(NULL,0,FastEma,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEma,0,MODE_EMA,PRICE_CLOSE,i);
   for(i=0; i<limit; i++)
    ExtMapBufBlue[i]   = iMAOnArray(ExtMapBufGreen,Bars,Signal,0,MODE_SMA,i);
    
   for(i=0; i<limit; i++)
      {
      if (NormalizeDouble(ExtMapBufGreen[i] - ExtMapBufBlue[i],Digits) < 0)
         {
         ExtMapBufRed[i]= ExtMapBufGreen[i] - ExtMapBufBlue[i];
         }
      else
         {
         ExtMapBufLime[i]= ExtMapBufGreen[i] - ExtMapBufBlue[i];
         }
      }
//--------------------------------------------------------------------
   return;                          
  }
//--------------------------------------------------------------------