//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 PaleVioletRed

extern string TimeFrame       = "current time frame";
extern int    FastEmaPeriod   = 12;
extern int    SlowEmaPeriod   = 26;
extern int    SignalPeriod    = 9;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   ShowOnlyLastArrow = false;

extern string note7            = "Arrow Type";
extern string note8            = "0=default,1=Thick,2=Thin,3=Hollow";
extern string note9            = "4=Round,5=Fractal,6=Diagonal Thin";
extern string note10           = "7=Diagonal Thick,8=Diagonal Hollow";
extern string note11           = "9=Thumb,10=Finger,11=Bomb";
extern int    ArrowType        = 1;
extern int    ArrowSize        = 1;

//
//
//
//
//

double sigUp[];
double sigDn[];
double trend[];
int timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{
   IndicatorBuffers(3);

   if (ArrowType == 0) {
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0,DRAW_ARROW,0,ArrowSize); SetIndexArrow(0,119);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1,DRAW_ARROW,0,ArrowSize); SetIndexArrow(1,119);
   }
   if (ArrowType == 1) {
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 233);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 234);
   }
   else if (ArrowType == 2) { 
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 225);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 226);
   }
   else if (ArrowType == 3) { 
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 241);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 242);
   }
   else if (ArrowType == 4) { 
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 221);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 222);
   }
   else if (ArrowType == 5) { 
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 217);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 218);
   }
   else if (ArrowType == 6) { 
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 228);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 230);
   }
   else if (ArrowType == 7) { 
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 236);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 238);
   }
   else if (ArrowType == 8) { 
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 246);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 248);
   }
   else if (ArrowType == 9) { 
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 67);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 68);
   }
   else if (ArrowType == 10) { 
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 71);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 72);
   }
   else if (ArrowType == 11) { 
   SetIndexBuffer(0, sigUp);  SetIndexStyle(0, DRAW_ARROW,0,ArrowSize); SetIndexArrow(0, 77);
   SetIndexBuffer(1, sigDn);  SetIndexStyle(1, DRAW_ARROW,0,ArrowSize); SetIndexArrow(1, 77);
   }

   SetIndexBuffer(2,trend);
      timeFrame=stringToTimeFrame(TimeFrame);
      return(0);
}

//
//
//
//
//

int start() 
{

   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-1,MathMax(Bars-counted_bars,3*timeFrame/Period()));
         
      //
      //
      //
      //
      //

      for(int i = limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            double macd = iMACD(NULL,timeFrame,FastEmaPeriod,SlowEmaPeriod,SignalPeriod,PRICE_CLOSE,MODE_MAIN  ,y);
            double sign = iMACD(NULL,timeFrame,FastEmaPeriod,SlowEmaPeriod,SignalPeriod,PRICE_CLOSE,MODE_SIGNAL,y);

            //
            //
            //
            //
            //
            
            sigUp[i] = EMPTY_VALUE;
            sigDn[i] = EMPTY_VALUE;
            trend[i] = trend[i+1];
               if (macd>sign) trend[i] =  1;
               if (macd<sign) trend[i] = -1;
               if (trend[i] != trend[i+1])
                  if (trend[i]==1) 
                        sigUp[i] = Low[i] -iATR(NULL,0,10,i)/2.0;
                  else  sigDn[i] = High[i]+iATR(NULL,0,10,i)/2.0;
      }
      manageAlerts();
      
      //
      //
      //
      //
      //
      
      int drawBegin = 0;
         if (ShowOnlyLastArrow)
         {
            drawBegin=Bars-1; for (i=0; i<Bars && sigUp[i]==EMPTY_VALUE && sigDn[i]==EMPTY_VALUE; i++) { drawBegin--; }
         }
      SetIndexDrawBegin(0,drawBegin);
      SetIndexDrawBegin(1,drawBegin);
      
   return (0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MACD trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"MACD crossover"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

