//+------------------------------------------------------------------+
//|                                                          HMA.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 1
#property  indicator_color1  Blue

//---- indicator parameters

//---- indicator buffers
double     macdline[];
double     fema,sema,dif1,x1,x2;
extern double FastEMA=12;
extern double SlowEMA=26;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffers mapping
   IndicatorBuffers(1);
   //SetIndexBuffer(0,ind_buffer0) ;
   SetIndexBuffer(0,macdline);
   
    

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit,i;
   int counted_bars=IndicatorCounted();
//---- check for possible errors

//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- MA difference counted in the 1-st buffer
x1=2/(FastEMA+1);
x2=2/(SlowEMA+1);

for  (i=Bars-2;i>=0;i--) {
fema=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i+1);
sema=iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i+1);
dif1=iMACD(NULL,0,FastEMA,SlowEMA,9,PRICE_CLOSE,MODE_MAIN,i+1);

//(ma1[i]-ema11)*0.1538+ema11-((ma1[i]-ema25)*0.0741+ema25)-ma9=macd1;
//ma1[i]*0.1538-ema11*0.1538+ema11-ma1[i]*0.0741+ema25*0.0741-ema25=macd1+ma9
//ma1[i]*0.1538-ma1[i]*0.0741=dif1+ema11*0.1538-ema11-ema25*0.0741+ema25
macdline[i]=(dif1+fema*x1-fema-sema*x2+sema)/(x1-x2);
}

//Comment(x1);
   return(0);
  }