//+------------------------------------------------------------------+
//|                                                    MACD full.mq4 |
//|  :                                             |
//| -  MACD (FastEMA[12]-SlowEMA[26]  SignalISMA[9]);   |
//| -  MACD    SMA     | 
//|     (MACD[12,26]- SignalISMA[9]  SignSMA[5]).    |
//|                                                                  |
//| ,  Metatrader 4:                     |
//| - FastEMA=12;                                                    |
//| - SlowEMA=26;                                                    |
//| - SignalSMA=9;                                                   |                                                    
//|        8           |
//|( 8,3897), 18 ( 17,5185)  9 (   |
//|9,0503) .                                           |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2010, LenIFCHIK"
//----  
#property  indicator_separate_window                //  
#property  indicator_buffers 8                      // 6 
//----  
//----  MACD
#define COL_1 RoyalBlue                             //    MACD                             
#define COL_2 FireBrick                             //    MACD                             
#define COL_3 MidnightBlue                          //    MACD 
#define COL_4 LightSteelBlue                        //    MACD
#define COL_5 CornflowerBlue                        //    MACD
#define COL_6 C'86,138,235'                         // ""  MACD                         
#define COL_7 Red                                   //   MACD                                    
//---- MACD                            
#define COL_8 LightGray                             //  MACD 
#define COL_9 DarkGray                              //  MACD 
#define COL_10 DarkSlateGray                        // "" MACD
#define COL_11 Red                                  //   MACD
//----  
extern int FastEMA=8;                               //  EMA
extern int SlowEMA=18;                              //  EMA
extern int SignalSMA=9;                             //   MACD
extern int SignSMA=5;                               //    MACD
extern string MACD_Hist_display_mode="0 - nothing, 1 - line, 2 - histogram";
extern int MACD_Hist_disp=0;                        //   MACD (0- , 1-)
extern string MACD_display_mode="0 - nothing, 1 - line, 2 - histogram";
extern int MACD_disp=2;                             //  MACD (0- , 1-)
//----  :
//----   MACD
double     ExtBuffer1[];                            //    MACD 
double     ExtBuffer2[];                            //    MACD 
double     OsmaBuffer[];                            //  MACD
double     SignSMABuffer[];                         //    MACD
//----  MACD
double     ExtBuffer3[];                            //  MACD
double     ExtBuffer4[];                            //  MACD
double     MacdBuffer[];                            // MACD
double     SignalBuffer[];                          //   MACD

//+------------------------------------------------------------------+
//| .  init                                      |
//+------------------------------------------------------------------+
int init()
  {
//---- 2     
   IndicatorBuffers(8);                             //  
//----  :
//----  MACD 
   switch(MACD_Hist_disp)                           //   MACD
     {
      case 0 :                                      // 
        SetIndexStyle(0,DRAW_NONE);                 //    MACD 
        SetIndexStyle(1,DRAW_NONE);                 //    MACD 
        SetIndexStyle(2,DRAW_NONE);                 //   MACD 
        SetIndexStyle(3,DRAW_NONE);                 //    MACD 
        break;
      case 1 :                                           //    
        SetIndexStyle(0,DRAW_LINE, STYLE_SOLID,1,COL_1); //    MACD
        SetIndexStyle(1,DRAW_LINE, STYLE_SOLID,1,COL_2); //    MACD
        SetIndexStyle(2,DRAW_NONE, STYLE_SOLID,1,NULL);  //    MACD
        SetIndexStyle(3,DRAW_LINE, STYLE_SOLID,1,COL_3); //    MACD
        break;
      case 2 :                                                 //      
        SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID,1,COL_4);  //    MACD
        SetIndexStyle(1,DRAW_HISTOGRAM, STYLE_SOLID,1,COL_5);  //    MACD
        SetIndexStyle(2,DRAW_LINE, STYLE_SOLID,1,COL_6);       // ""  MACD 
        SetIndexStyle(3,DRAW_LINE, STYLE_SOLID,1,COL_7);       //    MACD      
      default :
        MACD_Hist_disp=0;                                //   
     }
//---- MACD
   switch(MACD_disp)                                     //  MACD
     {
      case 0 :                                           // 
        SetIndexStyle(4,DRAW_NONE);                      //  MACD 
        SetIndexStyle(5,DRAW_NONE);                      //  MACD 
        SetIndexStyle(6,DRAW_NONE);                      // "" MACD  
        SetIndexStyle(7,DRAW_NONE);                      //   MACD 
        break;
      case 1 :                                            //   
        SetIndexStyle(4,DRAW_NONE);                       //  MACD 
        SetIndexStyle(5,DRAW_NONE);                       //  MACD 
        SetIndexStyle(6,DRAW_LINE, STYLE_SOLID,1,COL_10); //  MACD  
        SetIndexStyle(7,DRAW_LINE, STYLE_SOLID,1,COL_11); //   MACD
        break;
      case 2 :                                                 //      
        SetIndexStyle(4,DRAW_HISTOGRAM, STYLE_SOLID,1,COL_8);  //  MACD 
        SetIndexStyle(5,DRAW_HISTOGRAM, STYLE_SOLID,1,COL_9);  //  MACD 
        SetIndexStyle(6,DRAW_LINE, STYLE_SOLID,1,COL_10);      // "" MACD  
        SetIndexStyle(7,DRAW_LINE, STYLE_SOLID,1,COL_11);      //   MACD
        break;
      default :
        MACD_disp=2;                                //      
     }       
//----   :
//----  MACD
   SetIndexDrawBegin(0,SlowEMA);                    //,        MACD
   SetIndexDrawBegin(1,SlowEMA);                    //,        MACD
   SetIndexDrawBegin(2,SlowEMA);                    //,      MACD
   SetIndexDrawBegin(3,SlowEMA);                    //,        MACD
//---- MACD
   SetIndexDrawBegin(4,SlowEMA);                    //,      MACD
   SetIndexDrawBegin(5,SlowEMA);                    //,      MACD
   SetIndexDrawBegin(6,SlowEMA);                    //,     MACD
   SetIndexDrawBegin(7,SlowEMA);                    //,       MACD   
//----  
   IndicatorDigits(Digits);                         //    
//----  :
//----  MACD
   SetIndexBuffer(0,ExtBuffer1);                    //    MACD 
   SetIndexBuffer(1,ExtBuffer2);                    //    MACD  
   SetIndexBuffer(2,OsmaBuffer);                    //  MACD
   SetIndexBuffer(3,SignSMABuffer);                 //    MACD
//---- MACD
   SetIndexBuffer(4,ExtBuffer3);                    //  MACD
   SetIndexBuffer(5,ExtBuffer4);                    //  MACD
   SetIndexBuffer(6,MacdBuffer);                    // MACD
   SetIndexBuffer(7,SignalBuffer);                  //   MACD
//----      
   IndicatorShortName("MACD full("+FastEMA+","+SlowEMA+","+SignalSMA+","+SignSMA+")"); 
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| MACD   MACD                                          |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   double current, current1, prev, prev1;
//----    
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----  MACD 
   for(int i=0; i<limit; i++)
      MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
//----    MACD
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
//----   MACD
   for(i=0; i<limit; i++)
      OsmaBuffer[i]=MacdBuffer[i]-SignalBuffer[i];
//----      MACD    
   for(i=0; i<limit; i++)
      SignSMABuffer[i]=iMAOnArray(OsmaBuffer,Bars,SignSMA,0,MODE_SMA,i);
//----          
   for(i=limit-1; i>=0; i--)
     {
      current=OsmaBuffer[i];                         //   MACD
      prev=OsmaBuffer[i+1];                          //   MACD
      current1=MacdBuffer[i];                        //  MACD                           
      prev1=MacdBuffer[i+1];                         //  MACD
//----   MACD
      if(current>=prev)                              //    MACD    , ...
        {
         ExtBuffer1[i]=current;                      //...    MACD,
         ExtBuffer2[i]=EMPTY_VALUE;                  //   MACD  
        }
      else                                           //  ...
        {
         ExtBuffer1[i]=current;                      //...    MACD,
         ExtBuffer2[i]=current;                      //   (    )
        }
//----  MACD
     if(current1>=prev1)                             //   MACD    , ...
        {
         ExtBuffer3[i]=current1;                     //...   MACD,
         ExtBuffer4[i]=EMPTY_VALUE;                  //  MACD  
        }
      else                                           //  ...
        {
         ExtBuffer4[i]=current1;                     //...   MACD,
         ExtBuffer3[i]=EMPTY_VALUE;                  //  MACD  
        {
     }
//---- 
     }
     }
   return(0);
  }
//+------------------------------------------------------------------+

