//+------------------------------------------------------------------+
//|                                       Custom MACD with Marks.mq4 |
//| RAMZAN Marking Version: http://www.forexfactory.com/ramzam       |
//| http://www.forexfactory.com/showthread.php?p=9214737#post9214737 |
//+------------------------------------------------------------------+
/*
i want EA for this. 
When blue arrow appears take one lot buy and stoploss place at the arrow value upto the candle close. 
- For next candle stoplose can be removed... the same for blue dot appearance ... too one lot buy and stoploss place for holding all lots at the dot value up to the candle close and for next candle stoploss can be removed.
When red arrow appears close all longs and enter one lot short and then place stoploss at arrow value.
- For next candle stoploss can be removed. same for red dot appearce also. 
Suppose stoploss hit means exit position and wait for next signal.
some time price moves nice on the side of the signal and fast return to initial price... so profit booking at 400 percent is there means any of time the price reach means that time book the short or long at said percent and wait for next signal. many time the book profit level wont come but rarely it will...
any one help me for this ... if i get this here means really i will get happy...
*/
#property  copyright "LukeB"
#property  link      "http://www.forexfactory.com/lukeb"
#property  strict
#property version "1.05"
#property  indicator_separate_window      // Only use separate or chart window, not both.
// #property  indicator_chart_window         // indicator_chart_window - Lines should likely be set to DRAW_NONE if this is used.  See OnInit, SetIndexStyle.
#property  indicator_buffers 2
//
const int NOSHIFT           = 0;
const int WINDOWZERO        = 0;
const int CHARTWINDOW       = 0;
const int ANCHOR_POINT_ZERO = 0;
const int ANCHOR_POINT_ONE  = 1;
const int LOW_HIGH          = 0;
const int CLOSE_CLOSE       = 1;
//
enum ENUM_ON_OFF               { ON, OFF };
enum ENUM_LONGORSHORT          { LONG, SHORT };
enum ENUM_SIGNAL_BAR           { BAR_ZERO, BAR_ONE };
enum ENUM_OSC_SUPRESSION       { OSC_SUP_OFF, RSI_ON, CCI_ON, STO_ON, endOSCSuppression }; //  Chose a version of suppression due to oscillator signals.
enum ENUM_OSC_SUPRESSION_VALUE { NOT_SUPPRESSED, SHORT_SUPPRESSED, LONG_SUPPRESSED};
//---- indicator parameters
extern int   FastEMA               = 12;
extern int   SlowEMA               = 26;
extern int   SignalSMA             = 9;
// Controls
extern ENUM_ON_OFF SameSideSuppression      = OFF;             // Turn suppression of Marks on the same side as indicator level on or off
extern ENUM_OSC_SUPRESSION OSC_SUPPRESSION  = RSI_ON;          // Choose to suppress signals based on oscillators
extern ENUM_TIMEFRAMES SUPPRESSION_TF       = PERIOD_CURRENT;  // TimeFrame for suppression value calculation.
extern ENUM_SIGNAL_BAR SignalBar            = BAR_ZERO;        // Calculate signal on ticks in Bar Zero or on last tick in Bar 1.
// Factors
extern double SL_Factor            = 0.01;   // Mulitply Signal Price by factor to get value
extern double TP1_Factor           = 0.015;  // Mulitply Signal Price by factor to get value
extern double TP2_Factor           = 0.025;  // Mulitply Signal Price by factor to get value
extern double TP3_Factor           = 0.034;  // Mulitply Signal Price by factor to get value
extern double ExtremeTP_Factor     = 0.045;  // Mulitply Signal Price by factor to get value
//
extern bool  MarkMACDCross         = true;
extern color LongMACDCrossClr      = clrDodgerBlue;
extern color ShortMACDCrossClr     = clrMagenta;
extern color LongLineLableClr      = clrAqua;
extern color ShortLineLableClr     = clrCoral;
extern bool  MarkZeroCross         = true;
extern color LongZeroCrossClr      = clrBlue;
extern color ShortZeroCrossClr     = clrRed;
extern int   MarkSize              = 18;
//
extern int    dispDigits              = 2;   // use -1 to display with "Digits" accuracy.
extern int	  RSI_Period	           = 14;  // double  iRSI( symbol, timeframe, period, applied_price, shift );
extern int    CCI_Period              = 15;  // double  iCCI( symbol, timeframe, period, applied_price, shift );
extern int    STO_K_Period            = 5;   // double  iStochastic(  symbol, timeframe, Kperiod, Dperiod, slowing, method, price_field, mode, shift);
extern int    STO_D_Period            = 3;
extern int    STO_Slowing             = 3;
//
extern string uniquifier           = "DotV2101";  // A String to make objects unique if you want more than one inicator of this type on a chart
//
const  uchar macdCrossUpChar       =  217;  // 217 = up arrow
const  uchar macdCrossDownChar     =  218;  // 218 = down arrow
const  uchar zeroCrossUpChar       =  108;  // 108 = solid dot
const  uchar zeroCrossDownChar     =  108;  // 108 = solid dot
//---- indicator buffers --------
double ind_maDifferance[];
double ind_difAverage[];
// --- Bar Color Buffers -----
//--------  On Chart Objects -----------
//------- Marks ----------
enum MARK_NAME_INDEX { MACD_CROSS_UP=0, SIGNAL_CROSS_DOWN, ZERO_CROSS_UP, ZERO_CROSS_DOWN, endMarkNames};
string markName[] =  { "MACDCrossUp",   "MACDCrossDown",   "ZeroCrossUp", "ZeroCrossDown" };
int markCount[endMarkNames];
//------- lines ----------
enum LINE_NAME_INDEX {SL_LINE=0,  ENTRY_LINE,    TP1_LINE,    TP2_LINE,    TP3_LINE,    ExtremeTP_LINE,  endLineNames};
string lineName[] = { "SL_Line",  "Entry_Line",  "TP1_Line",  "TP2_Line",  "TP3_Line",  "ExtremeTP_Line"   };
string labelName[]= { "SL_Label", "Entry_Label", "TP1_Label", "TP2_Label", "TP3_Label", "ExtremeTP_Label"  };
//------- Suppression Text Display --------
string suppressionObjectName = "Suppression_Display";
// int lineCount[endLineNames];
//--------- process helps --------------
double markOffset;
int    workDispDigits;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
 {
   int initResult = INIT_SUCCEEDED;
   IndicatorShortName(uniquifier);
   //
   ArrayInitialize(markCount,NULL);
   // ArrayInitialize(lineCount,NULL);
   //---- drawing settings
   IndicatorDigits(Digits + 1);
   //
   IndicatorSetInteger(INDICATOR_LEVELS, 1);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE, STYLE_DOT);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR, clrIvory);
   IndicatorSetInteger(INDICATOR_LEVELWIDTH, 1);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,0.0);
   //---- First Indicator Buffers Initialization -----------
   SetIndexBuffer(0,ind_maDifferance);
   // SetIndexStyle(0,DRAW_NONE);  // Draw or not?
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2, clrRed);
   SetIndexLabel(0,"Difference");
   //---- 2nd Indicator Buffers Initialization -----------
   SetIndexBuffer(1,ind_difAverage);
   // SetIndexStyle(1,DRAW_NONE);  // Draw or not?
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2, clrBlue);
   SetIndexLabel(1,"Average");
   //
   suppressionObjectName = uniquifier+suppressionObjectName;
   //
   for( MARK_NAME_INDEX i = 0; i < endMarkNames; i++)
    {
      markName[i] = uniquifier+markName[i];
    }
   //
   for( LINE_NAME_INDEX i = 0; i < endLineNames; i++)
    {
      lineName[i]  = uniquifier+lineName[i];
      labelName[i] = uniquifier+labelName[i];
    }
   if( Bars < SlowEMA )  // not enough bars, fail initialization
    {
      initResult = INIT_FAILED;
      Print("Not enough Bars, at least ",IntegerToString(SlowEMA)," bars are needed, initialization failed.");
    }
   if ( (dispDigits < 0) || (dispDigits > (Digits+1)) )
    {
      workDispDigits = Digits;
    }
   else
    {
      workDispDigits = dispDigits;
    }
   markOffset = GetRange(40)/2;  // get the average range of 40 bars to use to offset marks from the bars
   //---- initialization done
   return(initResult);
 }
double GetRange(int rangeBars)
 {
   double rangeTotal = 0;
   if( Bars < rangeBars )
    {
      Print("Not enough Bars, at least ",IntegerToString(40)," bars are needed.");
      rangeTotal = 20*Point;
    }
   else
    {
      for( int i = 1; i < rangeBars+1; i++ )
       {
         rangeTotal += High[i]-Low[i];
       }
    }
   return(NormalizeDouble(rangeTotal/rangeBars,Digits));
 }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
 {
   DeleteChartObjects();
 }
void DeleteChartObjects(void)
 {
   for( MARK_NAME_INDEX i = 0; i < endMarkNames; i++ )
    {
      for(int n = 1; n <= markCount[i]; n++ )
       {
         ObjectDelete(markName[i]+IntegerToString(n));
       }
    }
   for( LINE_NAME_INDEX i = 0; i < endLineNames; i++ )
    {
      ObjectDelete(lineName[i]);
      ObjectDelete(labelName[i]);
    }
   ObjectDelete(suppressionObjectName);
 }
string MakeObjectName( const string& objToName, int& objCount)
 {
   objCount++;
   return(objToName+IntegerToString(objCount) );
 }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, const int prev_calculated, const datetime &time[], const double &open[], const double &high[],
                const double &low[], const double &close[], const long& tick_volume[], const long& volume[], const int& spread[] )
 {
   int firstBar = (rates_total - prev_calculated);
   if( (firstBar >= rates_total) || (rates_total < SlowEMA) )   // prev_calculated == 0 or make sure to print something if the total bars is too small.
    {
      firstBar -=2;  // One less bar the firsttime
      Print("firstBar: ",IntegerToString(firstBar),", Rates Total: ",IntegerToString(rates_total),", Previously Calculated: ",IntegerToString(prev_calculated));
    }
   //
   LoadPrimaryIndicators( firstBar, ind_maDifferance );  // indicator of the difference between the slow and fast MA's
   //
   LoadDependentIndicators( firstBar, ind_maDifferance, ind_difAverage );  // Make a MA on the difference of the slow and fast MA's
   //
   return(rates_total);
 }
//
void LoadPrimaryIndicators(const int& firstBar, double& differences[] )
 {
   for( int processBar = firstBar; processBar >= 0; processBar--)
    {
      differences[processBar]=iMA(Symbol(),PERIOD_CURRENT,FastEMA,NOSHIFT,MODE_EMA,PRICE_CLOSE,processBar)-
                              iMA(Symbol(),PERIOD_CURRENT,SlowEMA,NOSHIFT,MODE_EMA,PRICE_CLOSE,processBar);
    }
 }
//
void LoadDependentIndicators(const int& firstBar, const double& differences[], double& difAverage[] )
 {
   for( int processBar = firstBar; processBar >= 0; processBar--)
    {
      difAverage[processBar]=iMAOnArray(differences,Bars,SignalSMA,NOSHIFT,MODE_SMA,processBar);
      //
      if(MarkMACDCross && (processBar < (Bars-5)) )
       {
         SetAssendingDifferenceMark(processBar, differences, difAverage );
         SetDecendingDifferenceMark(processBar, differences, difAverage );
       }
      if(MarkZeroCross && (processBar < (Bars-5)) )
       {
         SetAssendingZeroCrossMark(processBar, differences, difAverage );
         SetDecendingZeroCrossMark(processBar, differences, difAverage );
       }
    }
 }
//
void SetAssendingDifferenceMark(const int& processBar, const double& difference[], const double& difAverage[] )
 {
   int signalBar = (SignalBar==BAR_ZERO)?processBar:(processBar+1);
   // ENUM_OSC_SUPRESSION_VALUE suppression = GetOscSuppression( Time[processBar], LONG );
   ENUM_OSC_SUPRESSION_VALUE suppression = NOT_SUPPRESSED;
   //
   if ( (difference[signalBar+1] < difAverage[signalBar+1]) && (difference[signalBar] >= difAverage[signalBar]) && (suppression != LONG_SUPPRESSED) )   // Difference assends accross the average preparing for an assention zero crossing
    {
      if( ( SameSideSuppression==ON ) && (difAverage[signalBar] < 0) )
       {
         DrawAssendingDifferenceMark(signalBar);
       }
      else if( SameSideSuppression==OFF )
       {
         DrawAssendingDifferenceMark(signalBar);
       }
    }
 }
void DrawAssendingDifferenceMark(const int& signalBar )
 {
   static datetime mostRecent = 0;
   if(mostRecent < Time[signalBar]) // in live bar zero processing, you can get multiple marks per bar without this.
    {
      mostRecent        = Time[signalBar];
      string nameStr    = MakeObjectName(markName[MACD_CROSS_UP], markCount[MACD_CROSS_UP]);
      double price      = (Low[signalBar+1]<Low[signalBar]?Low[signalBar+1]:Low[signalBar]) - (markOffset/2);
      string displayStr = CharToString(macdCrossUpChar);
      MakeAMark( nameStr, price, Time[signalBar], displayStr, LongMACDCrossClr);
    }
 }
//
void SetDecendingDifferenceMark(const int& processBar, const double& difference[], const double& difAverage[] )
 {
   int signalBar = (SignalBar==BAR_ZERO)?processBar:(processBar+1);
   //ENUM_OSC_SUPRESSION_VALUE suppression = GetOscSuppression( Time[processBar], SHORT );
   ENUM_OSC_SUPRESSION_VALUE suppression = NOT_SUPPRESSED;
   //
   if( (difference[signalBar+1] > difAverage[signalBar+1]) && (difference[signalBar] <= difAverage[signalBar]) && (suppression != SHORT_SUPPRESSED) )  // Difference decends accross the average preparing for an decending zero crossing
    {
      if( (SameSideSuppression==ON) && (difAverage[signalBar] > 0) )
       {
         DrawDecendingDifferenceMark(signalBar);
       }
      else if( SameSideSuppression==OFF )
       {
         DrawDecendingDifferenceMark(signalBar);
       }
    }
 }
void DrawDecendingDifferenceMark(const int& signalBar)
 {
   static datetime mostRecent = 0;
   if(mostRecent < Time[signalBar]) // in live bar zero processing, you can get multiple marks per bar without this.
    {
      mostRecent        = Time[signalBar];
      string nameStr    = MakeObjectName(markName[SIGNAL_CROSS_DOWN], markCount[SIGNAL_CROSS_DOWN]);
      double price      = (High[signalBar+1]>High[signalBar]?High[signalBar+1]:High[signalBar]) + (markOffset/2);
      string displayStr = CharToString(macdCrossDownChar);
      MakeAMark( nameStr, price, Time[signalBar],displayStr, ShortMACDCrossClr);
    }
 }
//
void SetAssendingZeroCrossMark(const int& processBar, const double& differences[], const double& difAverage[] )
 {
   int signalBar = (SignalBar==BAR_ZERO)?processBar:(processBar+1);
   ENUM_OSC_SUPRESSION_VALUE suppression = GetOscSuppression( Time[processBar], LONG );
   //
   if( (differences[signalBar+1] < 0) && (differences[signalBar] >= 0) && (suppression != LONG_SUPPRESSED) )       // Assending accross the zero line
    {
      if( (SameSideSuppression==ON) && (difAverage[signalBar] < 0) )
       {
         DrawAssendingZeroCrossMark(signalBar);
       }
      else if( SameSideSuppression==OFF )
       {
         DrawAssendingZeroCrossMark(signalBar);
       }
    }
 }
void DrawAssendingZeroCrossMark(const int& signalBar)
 {
   static datetime mostRecent = 0;
   if(mostRecent < Time[signalBar]) // in live bar zero processing, you can get multiple marks per bar without this.
    {
      mostRecent         = Time[signalBar];
      string nameStr     = MakeObjectName(markName[ZERO_CROSS_UP], markCount[ZERO_CROSS_UP]);
      double price       = (Low[signalBar+1]<Low[signalBar]?Low[signalBar+1]:Low[signalBar]) - (markOffset);
      string displayStr  = CharToString(zeroCrossUpChar);
      MakeAMark( nameStr, price, Time[signalBar], displayStr, LongZeroCrossClr);
      //
      int operation      = OP_BUY;
      double signalPrice = (signalBar==0)?Ask:Open[signalBar]+(Ask-Bid);  // Buy is at Ask, use current spread to approx the Ask at the non-zero signalBar Time
      MakeLines( operation, mostRecent, signalPrice );
    }
 }
//
void SetDecendingZeroCrossMark(const int& processBar, const double& differences[], const double& difAverage[] )
 {
   int signalBar = (SignalBar==BAR_ZERO)?processBar:(processBar+1);
   ENUM_OSC_SUPRESSION_VALUE suppression = GetOscSuppression( Time[processBar], SHORT );
   //
   if( (differences[signalBar+1] > 0) && (differences[signalBar] <= 0) && (suppression != SHORT_SUPPRESSED) )  // decending accross the zero line
    {
      if( (SameSideSuppression==ON) && (difAverage[signalBar] > 0) )
       {
         DrawDecendingZeroCrossMark(signalBar);
       }
      else if( SameSideSuppression==OFF )
       {
         DrawDecendingZeroCrossMark(signalBar);
       }
    }
 }
void DrawDecendingZeroCrossMark(const int& signalBar)
 {
   static datetime mostRecent = 0;
   if(mostRecent < Time[signalBar]) // in live bar zero processing, you can get multiple marks per bar without this.
    {
      mostRecent         = Time[signalBar];
      string nameStr     = MakeObjectName(markName[ZERO_CROSS_DOWN], markCount[ZERO_CROSS_DOWN]);
      double price       = (High[signalBar+1]>High[signalBar]?High[signalBar+1]:High[signalBar]) + (markOffset);
      string displayStr  = CharToString(zeroCrossDownChar);
      MakeAMark( nameStr, price, Time[signalBar], displayStr, ShortZeroCrossClr);
      //
      int operation      = OP_SELL;
      double signalPrice = (signalBar==0)?Bid:Open[signalBar]+(Ask-Bid);  // Sell is at Bid, Open price is a Bid at the non-zero signalBar Time
      MakeLines( operation, mostRecent, signalPrice ); // MakeLines( const int& operation, const datetime& startTime, const double& signalPrice )
    }
 }
//
ENUM_OSC_SUPRESSION_VALUE GetOscSuppression( const datetime& processTime, const ENUM_LONGORSHORT LONGORSHORT )
 {
   ENUM_OSC_SUPRESSION_VALUE suppression;
   switch (OSC_SUPPRESSION)
    {
      case OSC_SUP_OFF:
         suppression = NOT_SUPPRESSED;
         break;
      case RSI_ON:
         suppression = GetRSISuppression(processTime, LONGORSHORT);
         break;
      case CCI_ON:
         suppression = GetiCCISuppression(processTime, LONGORSHORT);
         break;
      case STO_ON:
         suppression = GetStochasticSuppression(processTime, LONGORSHORT);
         break;
      default:
         suppression = NOT_SUPPRESSED;
         break;
    }
   return(suppression); 
 }
ENUM_OSC_SUPRESSION_VALUE GetRSISuppression(const datetime& processTime, const ENUM_LONGORSHORT& LONGORSHORT )
 {  // RSI:  Allow long signals if RSI > 50; allow short signals if RSI < 50.
    //       Allow long if signal is < 20; Allow short if signal is > 80
   ENUM_OSC_SUPRESSION_VALUE suppression = NOT_SUPPRESSED;
   double rsiValue = GetIndiValue( RSI_ON, processTime );
   switch (LONGORSHORT)  // should the current Long or Short signal be suppressed?
    {
      case LONG:
         if( (rsiValue < 50) && (rsiValue>20) )   // suppress Long signal when RSI is between 20 and 50
            suppression = LONG_SUPPRESSED;
         break;
      case SHORT:
         if( ( rsiValue > 50) && (rsiValue < 80) )  // suppress Short signal when RSI is between 50 and 80
            suppression = SHORT_SUPPRESSED;
         break;
      default:
         suppression = NOT_SUPPRESSED;
         break;
    }
   return( suppression );
 }
ENUM_OSC_SUPRESSION_VALUE GetiCCISuppression(const datetime& processTime, const ENUM_LONGORSHORT& LONGORSHORT )
 {  // CCI:  Allow long signals if CCI is above 60; allow short signals if CCI below -60.
   ENUM_OSC_SUPRESSION_VALUE suppression = NOT_SUPPRESSED;
   double cciValue = GetIndiValue( CCI_ON, processTime );
   switch (LONGORSHORT)
    {
      case LONG:
         if( cciValue < 60 )
            suppression = LONG_SUPPRESSED;
         break;
      case SHORT:
         if( cciValue  > -60 )
            suppression = SHORT_SUPPRESSED;
         break;
      default:
         suppression = NOT_SUPPRESSED;
         break;
    }
   return( suppression );
 }
ENUM_OSC_SUPRESSION_VALUE GetStochasticSuppression(const datetime& processTime, const ENUM_LONGORSHORT& LONGORSHORT )
 { // Sto:  Allow long signals if Sto is below 40; allow short signals if Sto is above 40.
   ENUM_OSC_SUPRESSION_VALUE suppression = NOT_SUPPRESSED;
   double stoValue = GetIndiValue( STO_ON, processTime );
   switch (LONGORSHORT)
    {
      case LONG:
         if(stoValue  > 40 )
            suppression = LONG_SUPPRESSED;
         break;
      case SHORT:
         if(stoValue  < 40 )
            suppression = SHORT_SUPPRESSED;
         break;
      default:
         suppression = NOT_SUPPRESSED;
         break;
    }
   return( suppression );
 }
//
double GetIndiValue( const ENUM_OSC_SUPRESSION indi, const datetime& processTime )
 {
   static datetime lastProcessTime = 0;
   datetime calcTime;
   static double calcValue=EMPTY_VALUE;
   if( lastProcessTime != processTime )  // Time has changed, was a new bar, recalculate suppression indicator values
    {
      int tfProcessBar  = iBarShift(Symbol(),SUPPRESSION_TF, processTime, false);   // Get the Bar Number for the MTF value
      //
      calcValue         = GetValueOfIndi(indi, tfProcessBar);                       // Get the value for the current suppression indicator
      //
      calcTime          = (tfProcessBar==0)?TimeCurrent():processTime;              // Connot think of a time, unless debugging, when users wouldn't see TimeCurrent 
      lastProcessTime   = processTime;                                              // No need to re-calculate until we get a new bar to test
      //  Display information about the suppression indicator
      string dispString = GetTFText(SUPPRESSION_TF)+" "+GetIndiDescTxt(indi)+": "+DoubleToStr(calcValue,workDispDigits)
                          +" @ "+IntegerToString(TimeHour(calcTime))+":"+IntegerToString(TimeMinute(calcTime))+":"+IntegerToString(TimeSeconds(calcTime));
      DisplaySuppression (suppressionObjectName, dispString );
    }
   return(calcValue);
 }
double GetValueOfIndi( const ENUM_OSC_SUPRESSION suppressionIndi, const int& tfProcessBar)
 {
   double indiValue;
   switch (suppressionIndi)
    {
      case RSI_ON:
         indiValue = iRSI(Symbol(), SUPPRESSION_TF, RSI_Period, PRICE_MEDIAN, tfProcessBar );  // might try PRICE_MEDIAN
         break;
      case CCI_ON:
         indiValue = iCCI(Symbol(), SUPPRESSION_TF, CCI_Period, PRICE_MEDIAN, tfProcessBar );
         break;
      case STO_ON:
         indiValue = iStochastic(Symbol(),SUPPRESSION_TF, STO_K_Period, STO_D_Period, STO_Slowing, MODE_SMA, CLOSE_CLOSE, MODE_MAIN, tfProcessBar);
         break;
      default:
         indiValue = 0;
         Print("GetIndiValue called with invalid Value: "+IntegerToString(suppressionIndi));
         break;
    }
   return(indiValue);
 }
//
void MakeAMark( const string& objNameStr, const double& price, const datetime& time, const string& markChar, const color& markClr)
 {
   static long chartID = ChartID();
   //
   int windowIndex = ObjectFind(objNameStr);
   if( windowIndex < 0 )                      // Not found, create - This should be the case every time in this implementation
    { // bool  ObjectCreate( long chart_id, string object_name, ENUM_OBJECT object_type, int sub_window, datetime time1, double price1) 
      ObjectCreate( chartID, objNameStr,  OBJ_TEXT, WINDOWZERO, time, price );
      ObjectSetDouble(chartID,objNameStr, OBJPROP_ANGLE,0);
      ObjectSetInteger(chartID,objNameStr,OBJPROP_SELECTABLE,false); 
      ObjectSetInteger(chartID,objNameStr,OBJPROP_SELECTED, false);
      ObjectSetInteger(chartID,objNameStr,OBJPROP_ANCHOR,ANCHOR_CENTER);
      ObjectSetInteger(chartID,objNameStr,OBJPROP_COLOR,    markClr);
      ObjectSetString(chartID,objNameStr, OBJPROP_TEXT,     markChar);
      ObjectSetString(chartID,objNameStr, OBJPROP_FONT,     "Wingdings");
      ObjectSetInteger(chartID,objNameStr,OBJPROP_FONTSIZE, MarkSize);
      ObjectSet(objNameStr,OBJPROP_HIDDEN,true);                  // Hidden, must press 'all' to see in object list
      ObjectSet(objNameStr,OBJPROP_BACK,  false);                 // Display on top of Background
    }
 }
//+------------------------------------------------------------------+
void MakeLines( const int& operation, const datetime& startTime, const double& signalPrice )
 {
   datetime endTime = startTime + (Period()*60*40);
   double price; string text;
   for(LINE_NAME_INDEX i=0; i<endLineNames; i++)
    {
      GetPriceText( i, operation, signalPrice, price, text);
      ManageLine ( lineName[i], startTime, price, endTime, GetLineColor(operation));
      ManageLabel(labelName[i], endTime,   price, text,    GetLineLabelColor(operation));
    }
 }
color GetLineColor(const int operation)
 {
   color lcolor = (operation==OP_BUY)?LongZeroCrossClr:ShortZeroCrossClr;
   return(lcolor);
 }
color GetLineLabelColor(const int operation)
 {
   color lcolor;
   switch (operation)
    {
      case OP_BUY:
         lcolor = LongLineLableClr;
         break;
      case OP_SELL:
         lcolor = ShortLineLableClr;
         break;
      default:
         lcolor = (operation==OP_BUY)?LongZeroCrossClr:ShortZeroCrossClr;
         break;
    }
   return(lcolor);
 }
//
void GetPriceText( const LINE_NAME_INDEX& idx, const int& operation, const double& signalPrice, double& price, string& text)
 {
   double entryPrice = signalPrice;
   switch (idx)
    {
      case SL_LINE:
         price = operation==OP_BUY?entryPrice-(SL_Factor*entryPrice):entryPrice+(SL_Factor*entryPrice);
         text  = "SL: "+DoubleToStr(price,Digits);
         break;
      case ENTRY_LINE:
         price = entryPrice;
         text  = "Entry: "+DoubleToStr(price,Digits);
         break;
      case TP1_LINE:
         price = operation==OP_BUY?entryPrice+(TP1_Factor*entryPrice):entryPrice-(TP1_Factor*entryPrice);
         text  = "TP1: "+DoubleToStr(price,Digits);
         break;
      case TP2_LINE:
         price = operation==OP_BUY?entryPrice+(TP2_Factor*entryPrice):entryPrice-(TP2_Factor*entryPrice);
         text  = "TP2: "+DoubleToStr(price,Digits);
         break;
      case TP3_LINE:
         price = operation==OP_BUY?entryPrice+(TP3_Factor*entryPrice):entryPrice-(TP3_Factor*entryPrice);
         text  = "TP3: "+DoubleToStr(price,Digits);
         break;
      case ExtremeTP_LINE:
         price = operation==OP_BUY?entryPrice+(ExtremeTP_Factor*entryPrice):entryPrice-(ExtremeTP_Factor*entryPrice);
         text  = "Extreme TP: "+DoubleToStr(price,Digits);
         break;
      default:
         Print("GetPrice called with invalid index: ",IntegerToString(idx));
         price = Bid;
         text  = "Unknown idx: "+IntegerToString(idx)+", Bid: "+DoubleToStr(Bid,Digits);
         break;
    }
 }
//
void ManageLine(const string& lName, const datetime& startTime, const double& price, const datetime& endTime, const color lColor)
 {
   if (ObjectFind(lName) < 0 )
    {
         ObjectCreate(lName, OBJ_TREND, CHARTWINDOW, startTime, price, endTime, price);
         ObjectSet(lName, OBJPROP_COLOR, lColor);
         ObjectSet(lName, OBJPROP_STYLE, STYLE_DOT);
         ObjectSet(lName, OBJPROP_WIDTH, 1);
         ObjectSet(lName, OBJPROP_SELECTED, False);
         ObjectSet(lName, OBJPROP_SELECTABLE, true);
         ObjectSet(lName, OBJPROP_HIDDEN, false);
         ObjectSet(lName, OBJPROP_RAY,false);
     }
    else
     {
         ObjectMove(lName,ANCHOR_POINT_ZERO,startTime,price);
         ObjectSet(lName, OBJPROP_COLOR, lColor);
         ObjectMove(lName,ANCHOR_POINT_ONE,endTime,price); 
     }
 }
void ManageLabel(const string& lName, const datetime& anchorTime, const double& anchorPrice, const string& lText, const color lColor)
 {
   static long chartID = ChartID();
   if ( ObjectFind(chartID,lName) < 0 )
    {
      ObjectCreate(chartID,lName,OBJ_TEXT,CHARTWINDOW,anchorTime,anchorPrice); // user will know if there is no text.  But, an error check is common. 
      ObjectSetDouble (chartID,lName,OBJPROP_ANGLE,     0.0);
      ObjectSetInteger(chartID,lName,OBJPROP_ANCHOR,    ANCHOR_RIGHT_LOWER);
      ObjectSetInteger(chartID,lName,OBJPROP_BACK,      true); 
      ObjectSetInteger(chartID,lName,OBJPROP_SELECTABLE,true); 
      ObjectSetInteger(chartID,lName,OBJPROP_SELECTED,  false); 
      ObjectSetInteger(chartID,lName,OBJPROP_HIDDEN,    false);
    }
   else
    {
      ObjectMove(lName, ANCHOR_POINT_ZERO, anchorTime, anchorPrice);
    }
   ObjectSetText(lName, lText, 12, "Century Gothic", lColor);
 }
//----------------------
void DisplaySuppression (const string& objName, const string& lText)
 {
   static long chartID = ChartID();
   int xPos = 5, yPos = 5;
   if ( ObjectFind(chartID,objName) < 0 )
    {
      ObjectCreate(chartID,objName,OBJ_LABEL,CHARTWINDOW, 0, 0);
      ObjectSetInteger(chartID,objName,OBJPROP_CORNER,    CORNER_LEFT_LOWER);
      ObjectSetInteger(chartID,objName,OBJPROP_ANCHOR,    ANCHOR_LEFT_LOWER);
      ObjectSetInteger(chartID,objName,OBJPROP_BACK,      true); 
      ObjectSetInteger(chartID,objName,OBJPROP_SELECTABLE,true); 
      ObjectSetInteger(chartID,objName,OBJPROP_SELECTED,  false); 
      ObjectSetInteger(chartID,objName,OBJPROP_HIDDEN,    false);
    }
   ObjectSetInteger(chartID,objName,OBJPROP_XDISTANCE,xPos);
   ObjectSetInteger(chartID,objName,OBJPROP_YDISTANCE,yPos);
   ObjectSetText(objName, lText, 12, "Calibri", clrGreenYellow);
 }
string GetTFText(ENUM_TIMEFRAMES tf)
 {
   string tfText;
   if(tf==PERIOD_CURRENT)
    {
      tf = (ENUM_TIMEFRAMES) Period();
    }
   switch (tf)
    {
      case PERIOD_M1:
         tfText="M1";
         break;
      case PERIOD_M5:
         tfText="M5";
         break;
      case PERIOD_M15:
         tfText="M15";
         break;
      case PERIOD_M30:
         tfText="M30";
         break;
      case PERIOD_H1:
         tfText="H1";
         break;
      case PERIOD_H4:
         tfText="H4";
         break;
      case PERIOD_D1:
         tfText="D1";
         break;
      case PERIOD_W1:
         tfText="W1";
         break;
      case PERIOD_MN1:
         tfText="MN1";
         break;
      default:
         tfText="Unknown";
         break;
    }
   return(tfText);
 }
string GetIndiDescTxt(const ENUM_OSC_SUPRESSION& indi)
 {
   string indiText;
   switch (indi)
    {
      case RSI_ON:
         indiText="RSI Value";
         break;
      case CCI_ON:
         indiText="CCI Value";
         break;
      case STO_ON:
         indiText="STO Value";
         break;
      default:
         indiText="Unknown";
         break;
    }
   return(indiText);
 }
//---