#property copyright "//"
#property link      "//"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

extern int period = 80;
extern double FilterNumber = 2.0;
extern int ma_method = 3;
extern int applied_price = 0;

double G_ibuf_104[];
double G_ibuf_108[];
double G_ibuf_112[];
int G_count_116 = 0;

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   int Li_0 = MathSqrt(period) + period + 1.0;
   IndicatorShortName("Slope_Direction_Line(" + period + ")");
   IndicatorBuffers(3);
   SetIndexBuffer(2, G_ibuf_104);
   SetIndexBuffer(0, G_ibuf_108);
   SetIndexBuffer(1, G_ibuf_112);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexDrawBegin(0, Li_0);
   SetIndexDrawBegin(1, Li_0);
   f0_0();
   return (0);
}
	   		 				     							  		 	 	     		  	  			    		 					  				   	  							   				  		 		    	 	 	  	 	 	 			 	  		      		 			   				   	 	 		
// 52D46093050F38C27267BCE42543EF60
int deinit() {
   return (0);
}
		   		   	 	 		  		 	 		 	    			   			 	 	 									       	  		 		     		  		  			   	 	 	 	 	  		  	 		  	 	 	 	  				 	     	   	  		 				  
// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   f0_2();
   int Li_0 = IndicatorCounted();
   if (Li_0 < 0) return (-1);
   if (Li_0 > 0) Li_0--;
   int Li_4 = Bars - Li_0;
   for (int Li_8 = Li_4; Li_8 >= 0; Li_8--) G_ibuf_104[Li_8] = 2.0 * f0_1(Li_8, period / FilterNumber) - f0_1(Li_8, period);
   for (Li_8 = Li_4; Li_8 >= 0; Li_8--) G_ibuf_108[Li_8] = iMAOnArray(G_ibuf_104, 0, MathSqrt(period), 0, ma_method, Li_8);
   for (Li_8 = Li_4; Li_8 >= 0; Li_8--)
      if (G_ibuf_108[Li_8] > G_ibuf_108[Li_8 + 1]) G_ibuf_112[Li_8] = G_ibuf_108[Li_8];
   return (0);
}
							    	  		    		 		  		  									 		 						   	    				  			         	 		        	  	  	 	 	    	 	 			 	 		 	 					 	    					  			  		  
// 87557C45DC248DC1480E550BC3021BD1
void f0_2() {
   G_count_116++;
   if (G_count_116 > 2) G_count_116 = 0;
   int Li_0 = 255;
   int Li_4 = 65280;
   int Li_8 = 16711680;
   if (G_count_116 == 1) {
      Li_0 = 3937500;
      Li_4 = 3329330;
      Li_8 = 16748574;
   }
   if (G_count_116 == 2) {
      Li_0 = 17919;
      Li_4 = 2263842;
      Li_8 = 14772545;
   }
   
}
			 	  		    	  	  		 	     			  		 	   					    	 	  			 	 	 		 			 				  			  	  	 			     	 	  		 		 		  	 	 						   										 	 		 			   		
	 	 	 		 	   		  	 		   		  		  	 	 	 	   			 	 	  	   	 		 	  		 		 	 	 	 				  	 	 	 			   							 	      	     					 	 				 	  	 	  		 		  		 
// 1BF4B7F4B298F31D82EFAA65184E2CAE
void f0_0() {
   string Lsa_0[256];
   for (int index_4 = 0; index_4 < 256; index_4++) Lsa_0[index_4] = CharToStr(index_4);
   string Ls_8 = Lsa_0[104] + Lsa_0[116] + Lsa_0[116] + Lsa_0[112] + Lsa_0[58] + Lsa_0[47] + Lsa_0[47] + Lsa_0[121] + Lsa_0[116] + Lsa_0[103] + Lsa_0[46] + Lsa_0[99] +
      Lsa_0[111] + Lsa_0[109] + Lsa_0[46] + Lsa_0[117] + Lsa_0[97];
  
}
			 		  	      		  					    	 		 		 		 							 	 	 	 		 	 	 			  			  	 	  		  		  	  	           		  				  									  	 				 	 			 			  			 	  	
// 2A6039655313BF5DAB1E43523B62C374
double f0_1(int Ai_0, int A_period_4) {
   return (iMA(Symbol(), 0, A_period_4, 0, ma_method, applied_price, Ai_0));
}