//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  LimeGreen
#property indicator_color2  DarkOrange
#property indicator_color3  Green
#property indicator_color4  Red
#property indicator_color5  Silver
#property indicator_color6  Gray
#property indicator_color7  White
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_style7  STYLE_DOT

//
//
//
//
//

extern int MacdPrice   =  PRICE_CLOSE;
extern int MacdFast    =  12;
extern int MacdSlow    =  26;
extern int MacdSignal  =  9;

double macd1up[];
double macd1dn[];
double macd1ln[];
double macd1si[];
double macd2up[];
double macd2dn[];
double macd2ln[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,macd1up); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macd1dn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,macd2up); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,macd2dn); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,macd1ln);
   SetIndexBuffer(5,macd2ln);
   SetIndexBuffer(6,macd1si);
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   //

   double alpha = 2.0/(1.0+MacdSignal);
   for(i=limit; i >= 0; i--)
   {
      macd1ln[i] = iMA(NULL,0,MacdFast,0,MODE_EMA,MacdPrice,i)-iMA(NULL,0,MacdSlow,0,MODE_EMA,MacdPrice,i);
      macd1si[i] = macd1si[i+1]+alpha*(macd1ln[i]-macd1si[i+1]);
      macd2ln[i] = macd1ln[i]-macd1si[i];
      macd1up[i] = EMPTY_VALUE;
      macd1dn[i] = EMPTY_VALUE;
      macd2up[i] = EMPTY_VALUE;
      macd2dn[i] = EMPTY_VALUE;
         if (macd1ln[i]>0) macd1up[i] = macd1ln[i];
         if (macd1ln[i]<0) macd1dn[i] = macd1ln[i];
         if (macd2ln[i]>0) macd2up[i] = macd2ln[i];
         if (macd2ln[i]<0) macd2dn[i] = macd2ln[i];
   }   
   return(0);
}


