#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 C'112,112,112'
#property indicator_color2 White
#property indicator_color3 Lime
#property indicator_color4 DeepPink
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
#property indicator_level1 0
#property indicator_levelcolor1 C'112,112,112'
#property indicator_levelwidth1 1

extern int FastEMA = 12;
extern int SlowEMA = 26;
extern int SignalSMA = 9;
extern bool AlertMe = FALSE;
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
double g_ibuf_104[];

int init() {
//   if (ObjectType("MACDA") != 23) ObjectDelete("MACDA");
//   if (ObjectFind("MACDA") == -1) ObjectCreate("MACDA", OBJ_LABEL, 0, Time[5], Close[5]);
 //  ObjectSetText("MACDA", "MACD Alert");
 //  ObjectSet("MACDA", OBJPROP_XDISTANCE, 10);
 //  ObjectSet("MACDA", OBJPROP_YDISTANCE, 10);
 //  SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexDrawBegin(1, SignalSMA);
   IndicatorDigits(Digits + 1);
   SetIndexBuffer(0, g_ibuf_92);
   SetIndexBuffer(1, g_ibuf_96);
   SetIndexBuffer(2, g_ibuf_100);
   SetIndexBuffer(3, g_ibuf_104);
 //  IndicatorShortName("MACD (" + FastEMA + "," + SlowEMA + "," + SignalSMA + ")");
   SetIndexLabel(0, "MACD");
   SetIndexLabel(1, "Signal");
   return (0);
}

int deinit() {
   ObjectDelete("MACDA");
   return (0);
}

int start() {
//   if (ObjectType("MACDA") != 23) ObjectDelete("MACDA");
//   if (ObjectFind("MACDA") == -1) ObjectCreate("MACDA", OBJ_LABEL, 0, Time[5], Close[5]);
//   ObjectSetText("MACDA", "MACD Alert");
//   ObjectSet("MACDA", OBJPROP_XDISTANCE, 10);
//   ObjectSet("MACDA", OBJPROP_YDISTANCE, 10);
   int li_4 = IndicatorCounted();
   if (li_4 > 0) li_4--;
   int l_bars_0 = Bars;
   for (int li_8 = 0; li_8 < l_bars_0; li_8++) g_ibuf_92[li_8] = iMA(NULL, 0, FastEMA, 0, MODE_EMA, PRICE_CLOSE, li_8) - iMA(NULL, 0, SlowEMA, 0, MODE_EMA, PRICE_CLOSE, li_8);
   for (li_8 = 0; li_8 < l_bars_0; li_8++) g_ibuf_96[li_8] = iMAOnArray(g_ibuf_92, Bars, SignalSMA, 0, MODE_SMA, li_8);
   for (li_8 = 0; li_8 < l_bars_0; li_8++) {
      if (g_ibuf_92[li_8] > g_ibuf_96[li_8]) g_ibuf_100[li_8] = g_ibuf_92[li_8];
      else g_ibuf_104[li_8] = g_ibuf_92[li_8];
   }
   if (g_ibuf_100[1] == g_ibuf_92[1] && g_ibuf_100[2] != g_ibuf_92[2] && AlertMe) Alert("MACD: Long signal!");
   if (g_ibuf_104[1] == g_ibuf_92[1] && g_ibuf_104[2] != g_ibuf_92[2] && AlertMe) Alert("MACD: Short signal!");
   return (0);
}
