//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  OrangeRed
#property indicator_color3  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int FastEMA   = 12;
extern int SlowEMA   = 26;
extern int MacdPrice = PRICE_CLOSE;
extern int RsiPeriod = 14;
extern int RsiPrice  = PRICE_CLOSE;

double trup[];
double trdn[];
double trne[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,trup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,trdn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trne); SetIndexStyle(2,DRAW_HISTOGRAM);
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=Bars-counted_bars;
  
   for(int i=limit; i>=0; i--)
   {
      double macd = iMA(NULL,0,FastEMA,0,MODE_EMA,MacdPrice,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,MacdPrice,i);
      double rsi  = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
         trup[i]  = EMPTY_VALUE;
         trdn[i]  = EMPTY_VALUE;
         trne[i]  = EMPTY_VALUE;
            if (macd>0 && rsi > 50) { trup[i] = 1; continue; }
            if (macd<0 && rsi < 50) { trdn[i] = 1; continue; }
                                      trne[i] = 1;
   }
   return(0);         
}

