//+------------------------------------------------------------------+
//|                                            Stochastic triple.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
//2009fxtsd macd hilo

#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Blue
#property indicator_color2     Red


#property indicator_width1     1



extern int period1      = 5;
extern int method1      = 1;
extern int period2      = 9;
extern int method2      = 1;



double buffer1[];
double buffer2[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{

   
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);

   
   IndicatorShortName("macd hilo " +period1+"," +period2);  



   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+



int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;


   for(i=limit; i>=0; i--)
   {
   double      ma1h  = iMA(NULL, 0, period1, 0,method1 , 2, i); 
   double      ma1l  = iMA(NULL, 0, period1, 0,method1 , 3, i); 
   double      ma2h  = iMA(NULL, 0, period2, 0,method2 , 2, i); 
   double      ma2l  = iMA(NULL, 0, period2, 0,method2 , 3, i); 

   buffer1[i]=ma1h-ma2h;
   
   buffer2[i]=ma1l-ma2l;
 
 
   
  }
   
   return(0);
}


