//+------------------------------------------------------------------+
//|                                                    MACD Mixie.mq4|
//|                                          Copyright  2009, Ra457 |
//|                                                ra457fx@gmail.com |
//+------------------------------------------------------------------+


#property indicator_separate_window
#property indicator_buffers 3
#property indicator_level1 0.000000
#property  indicator_color1 Silver
#property  indicator_color2  Red
#property  indicator_width1  2

extern int    TimeFrame = 0;
extern int    FastEMA=12;
extern int    SlowEMA=26;
extern int    SignalSMA=9;

double     ExtMapBuffer1[];
double     MacdBuffer[];
double     SignalBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {


//---- name for DataWindow and indicator subwindow label   

   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 120 : TimeFrameStr="H2"; break;
      case 180 : TimeFrameStr="H3"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 360 : TimeFrameStr="H6"; break;
      case 720 : TimeFrameStr="H12"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   
   
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,SignalSMA);
   IndicatorDigits(Digits+4);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
   SetIndexBuffer(1,SignalBuffer);
//---- name for DataWindow and indicator subwindow label    
   IndicatorShortName(" something here ( "+TimeFrameStr+" ) ");
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"TimeFrame");
//---- initialization done
   return(0);

  
  
  }

//----

   return(0);
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
  {

   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted(); 

// Plot defined time frame on to current time frame

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit= Bars-1;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  

 iMACD(Symbol(),TimeFrame,12,26,9,PRICE_CLOSE,0,y); 
  
   ExtMapBuffer1[i]=iMACD(Symbol(),TimeFrame,12,26,9,PRICE_CLOSE,0,y);
   MacdBuffer[i]=iMACD(Symbol(),TimeFrame,12,26,9,PRICE_CLOSE,0,y);
   SignalBuffer[i]=iMACD(Symbol(),TimeFrame,12,26,9,PRICE_CLOSE,0,y);
   
  }
  }
//+------------------------------------------------------------------+