#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  OrangeRed
#property indicator_width1  2

extern int FastEma1 = 12;
extern int SlowEma1 = 26;
extern int Price    = PRICE_CLOSE;
extern int FastEma2 = 12;
extern int SlowEma2 = 26;

double macdofmacd[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() { SetIndexBuffer(0,macdofmacd); return(0); }
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

      //
      //
      //
      //
      //
   
      for(int i = limit; i >= 0; i--)
      {
         double price  = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         double macd   = iEma(price,FastEma1,i,0)-iEma(price,SlowEma1,i,1);
         macdofmacd[i] = iEma(macd,FastEma2,i,2)-iEma(macd,SlowEma1,i,3);
      }         
      return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][4];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

