//+------------------------------------------------------------------+
//|                                            Stochastic triple.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
//mod2009fxtsd      macd x3 triple str
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     Green
#property indicator_color2     DodgerBlue
#property indicator_color3     Goldenrod

#property indicator_width1     1
#property indicator_width2     1
#property indicator_width3     1
//#property indicator_minimum    -350
//#property indicator_maximum     350

//#property indicator_level1     100
//#property indicator_level2     -100
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//
extern string macd1 ="05,34,05";
extern string macd2 ="12,26,09";
extern string macd3 ="03,13,03";



//
//
//
//
//
double buffer1[];
double buffer2[];
double buffer3[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
      IndicatorBuffers(3); 

   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);

   IndicatorShortName("macd x3: "+macd1+"; "+macd2+"; "+macd3+"; ");  



   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//



int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   // 

   for(i=limit; i>=0; i--)
   {
 
      int a= StrToInteger( StringSubstr(macd1,0,3)); //5,34,5
      int b= StrToInteger( StringSubstr(macd1,3,6)); 
      int c= StrToInteger( StringSubstr(macd1,6,9)); 

      buffer1[i] = iMACD(NULL,0,a,b,c,PRICE_CLOSE,1,i);



      a=  StrToInteger( StringSubstr(macd2,0,3)); //12,26,9
      b=  StrToInteger( StringSubstr(macd2,3,6)); 
      c=  StrToInteger( StringSubstr(macd2,6,9)); 

      buffer2[i] = iMACD(NULL,0,a,b,c,PRICE_CLOSE,1,i);



      a= StrToInteger( StringSubstr(macd3,0,3)); 
      b= StrToInteger( StringSubstr(macd3,3,6)); 
      c= StrToInteger( StringSubstr(macd3,6,9)); 
  
      buffer3[i] = iMACD(NULL,0,a,b,c,PRICE_CLOSE,1,i);

    
    
      SetIndexLabel(0,"macd1 "+macd1);
      SetIndexLabel(1,"macd2:"+macd2);
      SetIndexLabel(2,"macd3 "+macd3);


   }
   
   return(0);
}


